﻿local tablet = AceLibrary("Tablet-2.0")
local L = AceLibrary("AceLocale-2.2"):new("OptiTaunt")
OptiTaunt = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "FuBarPlugin-2.0")

OptiTaunt.TOCversion = GetAddOnMetadata("OptiTaunt", "Version")
OptiTaunt.version = OptiTaunt.TOCversion
OptiTaunt.revision = OptiTaunt.TOCversion


function OptiTaunt:OnInitialize()
	self:RegisterDB("OptiTauntDB", "OptiTauntDBPC")
	self:RegisterDefaults("profile", {
				
	--messages
		resistmessage=L["resistmessage"],
		immunemessage=L["immunemessage"],
		abilitymessage=L["abilitymessage"],
		abilityendmessage=L["abilityendmessage"],
		abilityontargetmessage=L["abilityontargetmessage"],
		abilityontargetendmessage=L["abilityontargetendmessage"],
		instantcastmessage=L["instantcastmessage"],
		counterspellmessage=L["counterspellmessage"],
		procmessage=L["procmessage"],
		disarmmessage=L["disarmmessage"],
		disarmendmessage=L["disarmendmessage"],
		debuffmessage=L["debuffmessage"],
		debuffendmessage=L["debuffendmessage"],
		debuffstunmessage=L["debuffstunmessage"],
		debuffmagicmessage=L["debuffmagicmessage"],
		debuffcursemessage=L["debuffcursemessage"],
		debuffpoisonmessage=L["debuffpoisonmessage"],
		debuffdiseasemessage=L["debuffdiseasemessage"],
		healreqmessage=L["healreqmessage"],
				
	-- ouput
		outputsettings = {
		--Abilities
			--Druid
			["Growl"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Frenzied Regeneration"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Barkskin"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Survival Instincts"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Challenging Roar"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			--Warrior
			["Taunt"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Mocking Blow"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Shield Wall"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Last Stand"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Challenging Shout"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Enraged Regeneration"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Disarm"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Shield Bash"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Pummel"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			--Paladin
			["Righteous Defense"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Avenger's Shield"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Hand of Reckoning"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Divine Protection"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Ardent Defender"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Lay on Hands"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Hand of Protection"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			--Deathknight
			["Dark Command"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Death Grip"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Vampiric Blood"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Icebound Fortitude"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Anti-Magic Shell"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Unbreakable Armor"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Strangulate"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
		--Disarm
			["Disarm"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Dismantle"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Chimera Shot - Scorpid"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
		--Debuffs
			["Delirious Slash"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Rune of Blood"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Necrotic Strike"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Rend Flesh"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Banish"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Black Brand"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
		--Stun		
			["Blood Sap"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Shovelled!"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Hoarfrost"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Despair Stricken"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Kidney Shot"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
		--Magic debuff		
			["Polymorph: Spider"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Consuming Shadows"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Chains of Shadow"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Soul Sickness"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Impending Despair"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Shared Suffering"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Chains of Ice"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
		--Curse
			["Veil of Shadow"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Curse of Doom"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Cursed Arrow"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
		--Poison
			["Blinding Dirt"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Deadly Poison"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
		--Disease		
			["Leeching Rot"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
			["Blight"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
		--Heal req.		
			["Glacial Strike"] = {
						raid = true,
						say = false,
						whisper = false,
						raidwarning = false,
						channel = {},
			},
		},
			
	--options
		announceresist = true,
		announceimmune = true,
		announceability = true,
		announceabilityend = true,
		announceabilityontarget = true,
		announceabilityontargetend = true,
		announcedisarm = true,
		announcedisarmend = true,
		announcedebuff = true,
		announcedebuffend = false,
		announcedebuffstun = true,
		announcedebuffmagic = true,
		announcedebuffcurse = true,
		announcedebuffpoison = true,
		announcedebuffdisease = true,
		announcehealreq = true,
		
		giveAudioWarning = true,
		aggroCheck = true,
		whisperWarriors = false,
		pvpCheck = true,
		
	} )
	
	self:RegisterChatCommand(L["Slash-Commands"], self.options)
	self.opt = self.db.profile
	self.OnMenuRequest = self.options
	
	self.tauntsoundfile = "Interface\\AddOns\\OptiTaunt\\Sounds\\combo.ogg"
	self.tauntcount = 0
	self.tauntresistcount = 0
	self.tauntresistpercent = 0
	
	-- Only show class dependent ABILITIES and do some other class depending stuff
	_, self.playerclass	= UnitClass("player")
	if (self.playerclass == "DRUID") then
		self.ability_list = { L["Growl"], L["Challenging Roar"], L["Frenzied Regeneration"], L["Survival Instincts"], L["Barkskin"] }
	elseif (self.playerclass == "WARRIOR") then 
		self.ability_list = { L["Taunt"], L["Mocking Blow"], L["Shield Wall"], L["Last Stand"], L["Challenging Shout"], L["Enraged Regeneration"], L["Disarm"], L["Shield Bash"], L["Pummel"] }
	elseif (self.playerclass == "PALADIN") then
		self.ability_list = { L["Righteous Defense"], L["Avenger's Shield"], L["Hand of Reckoning"], L["Divine Protection"], L["Ardent Defender"], L["Lay on Hands"], L["Hand of Protection"] }
	elseif (self.playerclass == "DEATHKNIGHT") then
		self.ability_list = { L["Dark Command"], L["Death Grip"], L["Vampiric Blood"], L["Icebound Fortitude"], L["Anti-Magic Shell"], L["Unbreakable Armor"], L["Strangulate"] }
	else
		self.ability_list = { }
	end
	
	-- Only show class dependent DISARMS
	_, self.playerclass	= UnitClass("player")
	if (self.playerclass == "DRUID") then
		self.disarm_list = { }
	elseif (self.playerclass == "WARRIOR") then 
		self.disarm_list = { L["Disarm"], L["Dismantle"], L["Chimera Shot - Scorpid"] }
	elseif (self.playerclass == "PALADIN") then
		self.disarm_list = { L["Disarm"], L["Dismantle"], L["Chimera Shot - Scorpid"] }
	elseif (self.playerclass == "DEATHKNIGHT") then
		self.disarm_list = { L["Disarm"], L["Dismantle"], L["Chimera Shot - Scorpid"] }
	else
		self.disarm_list = { }
	end
	
	-- Only show (class dependent) DEBUFFS
	_, self.playerclass	= UnitClass("player")
	if (self.playerclass == "DRUID") then
		self.debuff_list = { L["Delirious Slash"], L["Rune of Blood"], L["Necrotic Strike"], L["Rend Flesh"], L["Banish"], L["Black Brand"] }
	elseif (self.playerclass == "WARRIOR") then 
		self.debuff_list = { L["Delirious Slash"], L["Rune of Blood"], L["Necrotic Strike"], L["Rend Flesh"], L["Banish"], L["Black Brand"] }
	elseif (self.playerclass == "PALADIN") then
		self.debuff_list = { L["Delirious Slash"], L["Rune of Blood"], L["Necrotic Strike"], L["Rend Flesh"], L["Banish"], L["Black Brand"] }
	elseif (self.playerclass == "DEATHKNIGHT") then
		self.debuff_list = { L["Delirious Slash"], L["Rune of Blood"], L["Necrotic Strike"], L["Rend Flesh"], L["Banish"], L["Black Brand"] }
	else
		self.debuff_list = { }
	end
	
	-- Only show (class dependent) STUN
	_, self.playerclass	= UnitClass("player")
	if (self.playerclass == "DRUID") then
		self.debuff_stun_list = { L["Blood Sap"], L["Shovelled!"], L["Hoarfrost"], L["Despair Stricken"], L["Kidney Shot"] }
	elseif (self.playerclass == "WARRIOR") then 
		self.debuff_stun_list = { L["Blood Sap"], L["Shovelled!"], L["Hoarfrost"], L["Despair Stricken"], L["Kidney Shot"] }
	elseif (self.playerclass == "PALADIN") then
		self.debuff_stun_list = { L["Blood Sap"], L["Shovelled!"], L["Hoarfrost"], L["Despair Stricken"], L["Kidney Shot"] }
	elseif (self.playerclass == "DEATHKNIGHT") then
		self.debuff_stun_list = { L["Blood Sap"], L["Shovelled!"], L["Hoarfrost"], L["Despair Stricken"], L["Kidney Shot"] }
	else
		self.debuff_stun_list = { }
	end
	
	-- Only show (class dependent) MAGIC debuffs
	_, self.playerclass	= UnitClass("player")
	if (self.playerclass == "DRUID") then
		self.debuff_magic_list = { L["Polymorph: Spider"], L["Consuming Shadows"], L["Chains of Shadow"], L["Soul Sickness"], L["Impending Despair"], L["Shared Suffering"], L["Chains of Ice"] }
	elseif (self.playerclass == "WARRIOR") then 
		self.debuff_magic_list = { L["Polymorph: Spider"], L["Consuming Shadows"], L["Chains of Shadow"], L["Soul Sickness"], L["Impending Despair"], L["Shared Suffering"], L["Chains of Ice"] }
	elseif (self.playerclass == "PALADIN") then
		self.debuff_magic_list = { L["Polymorph: Spider"], L["Consuming Shadows"], L["Chains of Shadow"], L["Soul Sickness"], L["Impending Despair"], L["Shared Suffering"], L["Chains of Ice"] }
	elseif (self.playerclass == "DEATHKNIGHT") then
		self.debuff_magic_list = { L["Polymorph: Spider"], L["Consuming Shadows"], L["Chains of Shadow"], L["Soul Sickness"], L["Impending Despair"], L["Shared Suffering"], L["Chains of Ice"] }
	else
		self.debuff_magic_list = { }
	end
	
	-- Only show (class dependent) CURSE
	_, self.playerclass	= UnitClass("player")
	if (self.playerclass == "DRUID") then
		self.debuff_curse_list = { L["Veil of Shadow"], L["Curse of Doom"], L["Cursed Arrow"] }
	elseif (self.playerclass == "WARRIOR") then 
		self.debuff_curse_list = { L["Veil of Shadow"], L["Curse of Doom"], L["Cursed Arrow"] }
	elseif (self.playerclass == "PALADIN") then
		self.debuff_curse_list = { L["Veil of Shadow"], L["Curse of Doom"], L["Cursed Arrow"] }
	elseif (self.playerclass == "DEATHKNIGHT") then
		self.debuff_curse_list = { L["Veil of Shadow"], L["Curse of Doom"], L["Cursed Arrow"] }
	else
		self.debuff_curse_list = { }
	end
	
	-- Only show (class dependent) POISON
	_, self.playerclass	= UnitClass("player")
	if (self.playerclass == "DRUID") then
		self.debuff_poison_list = { L["Blinding Dirt"], L["Deadly Poison"] }
	elseif (self.playerclass == "WARRIOR") then 
		self.debuff_poison_list = { L["Blinding Dirt"], L["Deadly Poison"] }
	elseif (self.playerclass == "PALADIN") then
		self.debuff_poison_list = { L["Blinding Dirt"], L["Deadly Poison"] }
	elseif (self.playerclass == "DEATHKNIGHT") then
		self.debuff_poison_list = { L["Blinding Dirt"], L["Deadly Poison"] }
	else
		self.debuff_poison_list = { }
	end
	
	-- Only show (class dependent) DISEASE
	_, self.playerclass	= UnitClass("player")
	if (self.playerclass == "DRUID") then
		self.debuff_disease_list = { L["Leeching Rot"], L["Blight"] }
	elseif (self.playerclass == "WARRIOR") then 
		self.debuff_disease_list = { L["Leeching Rot"], L["Blight"] }
	elseif (self.playerclass == "PALADIN") then
		self.debuff_disease_list = { L["Leeching Rot"], L["Blight"] }
	elseif (self.playerclass == "DEATHKNIGHT") then
		self.debuff_disease_list = { L["Leeching Rot"], L["Blight"] }
	else
		self.debuff_disease_list = { }
	end
	
	-- Only show (class dependent) HEAL REQUIRED
	_, self.playerclass	= UnitClass("player")
	if (self.playerclass == "DRUID") then
		self.healreq_list = { L["Glacial Strike"] }
	elseif (self.playerclass == "WARRIOR") then 
		self.healreq_list = { L["Glacial Strike"] }
	elseif (self.playerclass == "PALADIN") then
		self.healreq_list = { L["Glacial Strike"] }
	elseif (self.playerclass == "DEATHKNIGHT") then
		self.healreq_list = { L["Glacial Strike"] }
	else
		self.healreq_list = { }
	end
	
	-- Add custom channels
	OptiTaunt:CreateOutputSettings(self.ability_list)
	OptiTaunt:CreateOutputSettings2(self.disarm_list)
	OptiTaunt:CreateOutputSettings3(self.debuff_list)
	OptiTaunt:CreateOutputSettings4(self.debuff_stun_list)
	OptiTaunt:CreateOutputSettings5(self.debuff_magic_list)
	OptiTaunt:CreateOutputSettings6(self.debuff_curse_list)
	OptiTaunt:CreateOutputSettings7(self.debuff_poison_list)
	OptiTaunt:CreateOutputSettings8(self.debuff_disease_list)
	OptiTaunt:CreateOutputSettings9(self.healreq_list)
	
	-- set to 'true' for debugging messages / 'false' for no debugging messages
	self.isDebug = false

	DEFAULT_CHAT_FRAME:AddMessage("|cffff6d00OptiTaunt|r |cff8080ff"..OptiTaunt.TOCversion.."|r  by "..OptiTaunt.author.." loaded.");

end


function OptiTaunt:OnProfileEnable()
	self.opt = self.db.profile
end


function OptiTaunt:OnEnable()
    self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")	
	self:RegisterEvent("CHANNEL_UI_UPDATE")
end


-- debug function (must be activted under function 'OnInitialize()' - set 'self.isDebug = false' to 'self.isDebug = true')
function OptiTaunt:dbg(msg)
	if ( self.isDebug ) then
		OptiTaunt:Print(msg)
	end
end


--[[
---- Category (abilities) menu creation -----------------------------------------------------------
]]

-- Ability list creation, content is provided by 'OnInitialize()'
function OptiTaunt:CreateOutputSettings(ability_list)

	--something might have changed, so rebuild ability menu from scratch just to be safe
	local ability, activate
	self.channels = {GetChannelList()}
	self.options.args.ability_options.args = {}
				
	--rebuild abilites
	for ability=1,table.getn(ability_list) do
		self.options.args.ability_options.args[ability] = {}
		self.options.args.ability_options.args[ability] = {
			type  = 'group',
			name  = ability_list[ability],
			desc  = ability_list[ability],
			args  = {},
		}
	end
		
	--rebuild ability options
	for ability=1,table.getn(ability_list) do
		
		--raid/group
		self.options.args.ability_options.args[ability].args[1] = {
		type = 'toggle',
		order = 2,
		name = L["opt_name_raidparty"],
		desc = L["opt_desc_raidparty"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(ability_list[ability])].raid
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(ability_list[ability])].raid = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(ability_list[ability])].raid
		      end,
		}
		
		--say
		self.options.args.ability_options.args[ability].args[2] = {
		type = 'toggle',
		order = 1,
		name = L["opt_name_say"],
		desc = L["opt_desc_say"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(ability_list[ability])].say
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(ability_list[ability])].say = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(ability_list[ability])].say
		      end,
		}
		
		--whisper (disabled for activation announcements)
		if (L:GetReverseTranslation(ability_list[ability]) ~= "Challenging Roar") and 
		   (L:GetReverseTranslation(ability_list[ability]) ~= "Frenzied Regeneration") and 
		   (L:GetReverseTranslation(ability_list[ability]) ~= "Survival Instincts") and 
		   (L:GetReverseTranslation(ability_list[ability]) ~= "Barkskin") and 
		   (L:GetReverseTranslation(ability_list[ability]) ~= "Enraged Regeneration") and 
		   (L:GetReverseTranslation(ability_list[ability]) ~= "Shield Wall") and 
		   (L:GetReverseTranslation(ability_list[ability]) ~= "Last Stand") and 
		   (L:GetReverseTranslation(ability_list[ability]) ~= "Challenging Shout") and 
		   (L:GetReverseTranslation(ability_list[ability]) ~= "Disarm") and 
		   (L:GetReverseTranslation(ability_list[ability]) ~= "Shield Bash") and 
		   (L:GetReverseTranslation(ability_list[ability]) ~= "Pummel") and 
		   (L:GetReverseTranslation(ability_list[ability]) ~= "Avenger's Shield") and 
		   (L:GetReverseTranslation(ability_list[ability]) ~= "Divine Protection") and 		   
		   (L:GetReverseTranslation(ability_list[ability]) ~= "Ardent Defender") and 		   
		   (L:GetReverseTranslation(ability_list[ability]) ~= "Vampiric Blood") and 
		   (L:GetReverseTranslation(ability_list[ability]) ~= "Icebound Fortitude") and 
		   (L:GetReverseTranslation(ability_list[ability]) ~= "Anti-Magic Shell") and 
		   (L:GetReverseTranslation(ability_list[ability]) ~= "Unbreakable Armor") and 
		   (L:GetReverseTranslation(ability_list[ability]) ~= "Strangulate") then
			OptiTaunt.options.args.ability_options.args[ability].args[3] = {
				type = 'toggle',
				order = 4,
				name = L["opt_name_autowhisper"],
				desc = L["opt_desc_autowhisper"],
				get = function()
						return self.db.profile.outputsettings[L:GetReverseTranslation(ability_list[ability])].whisper
					  end,
				set = function()
						self.db.profile.outputsettings[L:GetReverseTranslation(ability_list[ability])].whisper = 
						not self.db.profile.outputsettings[L:GetReverseTranslation(ability_list[ability])].whisper
					  end,
				}
		else
			self.options.args.ability_options.args[ability].args[3] = nil
		end
		
		--Raidwarning
		self.options.args.ability_options.args[ability].args[4] = {
		type = 'toggle',
		order = 3,
		name = L["opt_name_raidwarning"],
		desc = L["opt_desc_raidwarning"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(ability_list[ability])].raidwarning
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(ability_list[ability])].raidwarning = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(ability_list[ability])].raidwarning
		      end,
		}
		
		--custom channels
		for i=5,table.getn(self.channels)/2+4 do
			self.options.args.ability_options.args[ability].args[i] = {
				type = 'toggle',
				name = self.channels[(i-4)*2],
				desc = self.channels[(i-4)*2],
			
				get = 	function()
							local rc = false
							for j=1,table.getn(self.db.profile.outputsettings[L:GetReverseTranslation(ability_list[ability])].channel) do
								if self.db.profile.outputsettings[L:GetReverseTranslation(ability_list[ability])].channel[j] == self.channels[(i-4)*2] then 
									rc = true 
								end
							end
							return rc
						end,
				set = 	function()
							local deletion = false
							for j=1,table.getn(self.db.profile.outputsettings[L:GetReverseTranslation(ability_list[ability])].channel) do
								if self.db.profile.outputsettings[L:GetReverseTranslation(ability_list[ability])].channel[j] == self.channels[(i-4)*2] then
									table.remove(self.db.profile.outputsettings[L:GetReverseTranslation(ability_list[ability])].channel, j)
									deletion=true
								end
							end
							if not deletion then
								table.insert(self.db.profile.outputsettings[L:GetReverseTranslation(ability_list[ability])].channel, self.channels[(i-4)*2])
							end
						end,
				}
		end
	end
end

-- Disarm (Tank debuff) list creation, content is provided by 'OnInitialize()'
function OptiTaunt:CreateOutputSettings2(disarm_list)

	--
	local disarm, activate
	self.channels = {GetChannelList()}
	self.options.args.disarm_options.args = {}
				
	--rebuild disarms
	for disarm=1,table.getn(disarm_list) do
		self.options.args.disarm_options.args[disarm] = {}
		self.options.args.disarm_options.args[disarm] = {
			type  = 'group',
			name  = disarm_list[disarm],
			desc  = disarm_list[disarm],
			args  = {},
		}
	end
		
	--rebuild disarm options
	for disarm=1,table.getn(disarm_list) do
		
		--raid/group
		self.options.args.disarm_options.args[disarm].args[1] = {
		type = 'toggle',
		order = 2,
		name = L["opt_name_raidparty"],
		desc = L["opt_desc_raidparty"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(disarm_list[disarm])].raid
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(disarm_list[disarm])].raid = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(disarm_list[disarm])].raid
		      end,
		}
		
		--say
		self.options.args.disarm_options.args[disarm].args[2] = {
		type = 'toggle',
		order = 1,
		name = L["opt_name_say"],
		desc = L["opt_desc_say"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(disarm_list[disarm])].say
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(disarm_list[disarm])].say = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(disarm_list[disarm])].say
		      end,
		}
		
		--whisper (disabled for activation announcements)
		if (L:GetReverseTranslation(disarm_list[disarm]) ~= "Disarm") and 
		   (L:GetReverseTranslation(disarm_list[disarm]) ~= "Dismantle") and 
		   (L:GetReverseTranslation(disarm_list[disarm]) ~= "Chimera Shot - Scorpid") then
			OptiTaunt.options.args.disarm_options.args[disarm].args[3] = {
				type = 'toggle',
				order = 4,
				name = L["opt_name_autowhisper"],
				desc = L["opt_desc_autowhisper"],
				get = function()
						return self.db.profile.outputsettings[L:GetReverseTranslation(disarm_list[disarm])].whisper
					  end,
				set = function()
						self.db.profile.outputsettings[L:GetReverseTranslation(disarm_list[disarm])].whisper = 
						not self.db.profile.outputsettings[L:GetReverseTranslation(disarm_list[disarm])].whisper
					  end,
				}
		else
			self.options.args.disarm_options.args[disarm].args[3] = nil
		end
		
		--Raidwarning
		self.options.args.disarm_options.args[disarm].args[4] = {
		type = 'toggle',
		order = 3,
		name = L["opt_name_raidwarning"],
		desc = L["opt_desc_raidwarning"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(disarm_list[disarm])].raidwarning
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(disarm_list[disarm])].raidwarning = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(disarm_list[disarm])].raidwarning
		      end,
		}
		
		--custom channels
		for i=5,table.getn(self.channels)/2+4 do
			self.options.args.disarm_options.args[disarm].args[i] = {
				type = 'toggle',
				name = self.channels[(i-4)*2],
				desc = self.channels[(i-4)*2],
			
				get = 	function()
							local rc = false
							for j=1,table.getn(self.db.profile.outputsettings[L:GetReverseTranslation(disarm_list[disarm])].channel) do
								if self.db.profile.outputsettings[L:GetReverseTranslation(disarm_list[disarm])].channel[j] == self.channels[(i-4)*2] then 
									rc = true 
								end
							end
							return rc
						end,
				set = 	function()
							local deletion = false
							for j=1,table.getn(self.db.profile.outputsettings[L:GetReverseTranslation(disarm_list[disarm])].channel) do
								if self.db.profile.outputsettings[L:GetReverseTranslation(disarm_list[disarm])].channel[j] == self.channels[(i-4)*2] then
									table.remove(self.db.profile.outputsettings[L:GetReverseTranslation(disarm_list[disarm])].channel, j)
									deletion=true
								end
							end
							if not deletion then
								table.insert(self.db.profile.outputsettings[L:GetReverseTranslation(disarm_list[disarm])].channel, self.channels[(i-4)*2])
							end
						end,
				}
		end
	end
end

-- Debuff (not dispellable) list creation, content is provided by 'OnInitialize()'
function OptiTaunt:CreateOutputSettings3(debuff_list)

	--
	local debuff, activate
	self.channels = {GetChannelList()}
	self.options.args.debuff_menu.args.debuff_options.args = {}
				
	--rebuild debuffs
	for debuff=1,table.getn(debuff_list) do
		self.options.args.debuff_menu.args.debuff_options.args[debuff] = {}
		self.options.args.debuff_menu.args.debuff_options.args[debuff] = {
			type  = 'group',
			name  = debuff_list[debuff],
			desc  = debuff_list[debuff],
			args  = {},
		}
	end
		
	--rebuild debuff options
	for debuff=1,table.getn(debuff_list) do
		
		--raid/group
		self.options.args.debuff_menu.args.debuff_options.args[debuff].args[1] = {
		type = 'toggle',
		order = 2,
		name = L["opt_name_raidparty"],
		desc = L["opt_desc_raidparty"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_list[debuff])].raid
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(debuff_list[debuff])].raid = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_list[debuff])].raid
		      end,
		}
		
		--say
		self.options.args.debuff_menu.args.debuff_options.args[debuff].args[2] = {
		type = 'toggle',
		order = 1,
		name = L["opt_name_say"],
		desc = L["opt_desc_say"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_list[debuff])].say
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(debuff_list[debuff])].say = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_list[debuff])].say
		      end,
		}
		
		--whisper (disabled for activation announcements)
		if (L:GetReverseTranslation(debuff_list[debuff]) ~= "Delirious Slash") and 
		   (L:GetReverseTranslation(debuff_list[debuff]) ~= "Rune of Blood") and 
		   (L:GetReverseTranslation(debuff_list[debuff]) ~= "Necrotic Strike") and 
		   (L:GetReverseTranslation(debuff_list[debuff]) ~= "Rend Flesh") and 
		   (L:GetReverseTranslation(debuff_list[debuff]) ~= "Banish") and 
		   (L:GetReverseTranslation(debuff_list[debuff]) ~= "Black Brand") then
			OptiTaunt.options.args.debuff_options.args[debuff].args[3] = {
				type = 'toggle',
				order = 4,
				name = L["opt_name_autowhisper"],
				desc = L["opt_desc_autowhisper"],
				get = function()
						return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_list[debuff])].whisper
					  end,
				set = function()
						self.db.profile.outputsettings[L:GetReverseTranslation(debuff_list[debuff])].whisper = 
						not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_list[debuff])].whisper
					  end,
				}
		else
			self.options.args.debuff_menu.args.debuff_options.args[debuff].args[3] = nil
		end
		
		--Raidwarning
		self.options.args.debuff_menu.args.debuff_options.args[debuff].args[4] = {
		type = 'toggle',
		order = 3,
		name = L["opt_name_raidwarning"],
		desc = L["opt_desc_raidwarning"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_list[debuff])].raidwarning
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(debuff_list[debuff])].raidwarning = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_list[debuff])].raidwarning
		      end,
		}
		
		--custom channels
		for i=5,table.getn(self.channels)/2+4 do
			self.options.args.debuff_menu.args.debuff_options.args[debuff].args[i] = {
				type = 'toggle',
				name = self.channels[(i-4)*2],
				desc = self.channels[(i-4)*2],
			
				get = 	function()
							local rc = false
							for j=1,table.getn(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_list[debuff])].channel) do
								if self.db.profile.outputsettings[L:GetReverseTranslation(debuff_list[debuff])].channel[j] == self.channels[(i-4)*2] then 
									rc = true 
								end
							end
							return rc
						end,
				set = 	function()
							local deletion = false
							for j=1,table.getn(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_list[debuff])].channel) do
								if self.db.profile.outputsettings[L:GetReverseTranslation(debuff_list[debuff])].channel[j] == self.channels[(i-4)*2] then
									table.remove(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_list[debuff])].channel, j)
									deletion=true
								end
							end
							if not deletion then
								table.insert(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_list[debuff])].channel, self.channels[(i-4)*2])
							end
						end,
				}
		end
	end
end

-- Stun (Tank debuff) list creation, content is provided by 'OnInitialize()'
function OptiTaunt:CreateOutputSettings4(debuff_stun_list)

	--
	local debuff_stun, activate
	self.channels = {GetChannelList()}
	self.options.args.debuff_menu.args.debuff_stun_options.args = {}
				
	--rebuild debuff_stuns
	for debuff_stun=1,table.getn(debuff_stun_list) do
		self.options.args.debuff_menu.args.debuff_stun_options.args[debuff_stun] = {}
		self.options.args.debuff_menu.args.debuff_stun_options.args[debuff_stun] = {
			type  = 'group',
			name  = debuff_stun_list[debuff_stun],
			desc  = debuff_stun_list[debuff_stun],
			args  = {},
		}
	end
		
	--rebuild debuff_stun options
	for debuff_stun=1,table.getn(debuff_stun_list) do
		
		--raid/group
		self.options.args.debuff_menu.args.debuff_stun_options.args[debuff_stun].args[1] = {
		type = 'toggle',
		order = 2,
		name = L["opt_name_raidparty"],
		desc = L["opt_desc_raidparty"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_stun_list[debuff_stun])].raid
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(debuff_stun_list[debuff_stun])].raid = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_stun_list[debuff_stun])].raid
		      end,
		}
		
		--say
		self.options.args.debuff_menu.args.debuff_stun_options.args[debuff_stun].args[2] = {
		type = 'toggle',
		order = 1,
		name = L["opt_name_say"],
		desc = L["opt_desc_say"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_stun_list[debuff_stun])].say
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(debuff_stun_list[debuff_stun])].say = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_stun_list[debuff_stun])].say
		      end,
		}
		
		--whisper (disabled for activation announcements)
		if (L:GetReverseTranslation(debuff_stun_list[debuff_stun]) ~= "Blood Sap") and 
		   (L:GetReverseTranslation(debuff_stun_list[debuff_stun]) ~= "Shovelled!") and 
		   (L:GetReverseTranslation(debuff_stun_list[debuff_stun]) ~= "Hoarfrost") and 
		   (L:GetReverseTranslation(debuff_stun_list[debuff_stun]) ~= "Despair Stricken") and 
		   (L:GetReverseTranslation(debuff_stun_list[debuff_stun]) ~= "Kidney Shot") then
			OptiTaunt.options.args.debuff_stun_options.args[debuff_stun].args[3] = {
				type = 'toggle',
				order = 4,
				name = L["opt_name_autowhisper"],
				desc = L["opt_desc_autowhisper"],
				get = function()
						return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_stun_list[debuff_stun])].whisper
					  end,
				set = function()
						self.db.profile.outputsettings[L:GetReverseTranslation(debuff_stun_list[debuff_stun])].whisper = 
						not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_stun_list[debuff_stun])].whisper
					  end,
				}
		else
			self.options.args.debuff_menu.args.debuff_stun_options.args[debuff_stun].args[3] = nil
		end
		
		--Raidwarning
		self.options.args.debuff_menu.args.debuff_stun_options.args[debuff_stun].args[4] = {
		type = 'toggle',
		order = 3,
		name = L["opt_name_raidwarning"],
		desc = L["opt_desc_raidwarning"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_stun_list[debuff_stun])].raidwarning
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(debuff_stun_list[debuff_stun])].raidwarning = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_stun_list[debuff_stun])].raidwarning
		      end,
		}
		
		--custom channels
		for i=5,table.getn(self.channels)/2+4 do
			self.options.args.debuff_menu.args.debuff_stun_options.args[debuff_stun].args[i] = {
				type = 'toggle',
				name = self.channels[(i-4)*2],
				desc = self.channels[(i-4)*2],
			
				get = 	function()
							local rc = false
							for j=1,table.getn(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_stun_list[debuff_stun])].channel) do
								if self.db.profile.outputsettings[L:GetReverseTranslation(debuff_stun_list[debuff_stun])].channel[j] == self.channels[(i-4)*2] then 
									rc = true 
								end
							end
							return rc
						end,
				set = 	function()
							local deletion = false
							for j=1,table.getn(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_stun_list[debuff_stun])].channel) do
								if self.db.profile.outputsettings[L:GetReverseTranslation(debuff_stun_list[debuff_stun])].channel[j] == self.channels[(i-4)*2] then
									table.remove(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_stun_list[debuff_stun])].channel, j)
									deletion=true
								end
							end
							if not deletion then
								table.insert(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_stun_list[debuff_stun])].channel, self.channels[(i-4)*2])
							end
						end,
				}
		end
	end
end

-- Magic (Tank debuff) list creation, content is provided by 'OnInitialize()'
function OptiTaunt:CreateOutputSettings5(debuff_magic_list)

	--
	local debuff_magic, activate
	self.channels = {GetChannelList()}
	self.options.args.debuff_menu.args.debuff_magic_options.args = {}
				
	--rebuild debuff_magics
	for debuff_magic=1,table.getn(debuff_magic_list) do
		self.options.args.debuff_menu.args.debuff_magic_options.args[debuff_magic] = {}
		self.options.args.debuff_menu.args.debuff_magic_options.args[debuff_magic] = {
			type  = 'group',
			name  = debuff_magic_list[debuff_magic],
			desc  = debuff_magic_list[debuff_magic],
			args  = {},
		}
	end
		
	--rebuild debuff_magic options
	for debuff_magic=1,table.getn(debuff_magic_list) do
		
		--raid/group
		self.options.args.debuff_menu.args.debuff_magic_options.args[debuff_magic].args[1] = {
		type = 'toggle',
		order = 2,
		name = L["opt_name_raidparty"],
		desc = L["opt_desc_raidparty"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_magic_list[debuff_magic])].raid
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(debuff_magic_list[debuff_magic])].raid = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_magic_list[debuff_magic])].raid
		      end,
		}
		
		--say
		self.options.args.debuff_menu.args.debuff_magic_options.args[debuff_magic].args[2] = {
		type = 'toggle',
		order = 1,
		name = L["opt_name_say"],
		desc = L["opt_desc_say"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_magic_list[debuff_magic])].say
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(debuff_magic_list[debuff_magic])].say = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_magic_list[debuff_magic])].say
		      end,
		}
		
		--whisper (disabled for activation announcements)
		if (L:GetReverseTranslation(debuff_magic_list[debuff_magic]) ~= "Polymorph: Spider") and 
		   (L:GetReverseTranslation(debuff_magic_list[debuff_magic]) ~= "Consuming Shadows") and 
		   (L:GetReverseTranslation(debuff_magic_list[debuff_magic]) ~= "Chains of Shadow") and 
		   (L:GetReverseTranslation(debuff_magic_list[debuff_magic]) ~= "Soul Sickness") and 
		   (L:GetReverseTranslation(debuff_magic_list[debuff_magic]) ~= "Impending Despair") and 
		   (L:GetReverseTranslation(debuff_magic_list[debuff_magic]) ~= "Shared Suffering") and 
		   (L:GetReverseTranslation(debuff_magic_list[debuff_magic]) ~= "Chains of Ice") then
			OptiTaunt.options.args.debuff_magic_options.args[debuff_magic].args[3] = {
				type = 'toggle',
				order = 4,
				name = L["opt_name_autowhisper"],
				desc = L["opt_desc_autowhisper"],
				get = function()
						return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_magic_list[debuff_magic])].whisper
					  end,
				set = function()
						self.db.profile.outputsettings[L:GetReverseTranslation(debuff_magic_list[debuff_magic])].whisper = 
						not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_magic_list[debuff_magic])].whisper
					  end,
				}
		else
			self.options.args.debuff_menu.args.debuff_magic_options.args[debuff_magic].args[3] = nil
		end
		
		--Raidwarning
		self.options.args.debuff_menu.args.debuff_magic_options.args[debuff_magic].args[4] = {
		type = 'toggle',
		order = 3,
		name = L["opt_name_raidwarning"],
		desc = L["opt_desc_raidwarning"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_magic_list[debuff_magic])].raidwarning
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(debuff_magic_list[debuff_magic])].raidwarning = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_magic_list[debuff_magic])].raidwarning
		      end,
		}
		
		--custom channels
		for i=5,table.getn(self.channels)/2+4 do
			self.options.args.debuff_menu.args.debuff_magic_options.args[debuff_magic].args[i] = {
				type = 'toggle',
				name = self.channels[(i-4)*2],
				desc = self.channels[(i-4)*2],
			
				get = 	function()
							local rc = false
							for j=1,table.getn(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_magic_list[debuff_magic])].channel) do
								if self.db.profile.outputsettings[L:GetReverseTranslation(debuff_magic_list[debuff_magic])].channel[j] == self.channels[(i-4)*2] then 
									rc = true 
								end
							end
							return rc
						end,
				set = 	function()
							local deletion = false
							for j=1,table.getn(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_magic_list[debuff_magic])].channel) do
								if self.db.profile.outputsettings[L:GetReverseTranslation(debuff_magic_list[debuff_magic])].channel[j] == self.channels[(i-4)*2] then
									table.remove(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_magic_list[debuff_magic])].channel, j)
									deletion=true
								end
							end
							if not deletion then
								table.insert(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_magic_list[debuff_magic])].channel, self.channels[(i-4)*2])
							end
						end,
				}
		end
	end
end

-- Curse (Tank debuff) list creation, content is provided by 'OnInitialize()'
function OptiTaunt:CreateOutputSettings6(debuff_curse_list)

	--
	local debuff_curse, activate
	self.channels = {GetChannelList()}
	self.options.args.debuff_menu.args.debuff_curse_options.args = {}
				
	--rebuild debuff_curses
	for debuff_curse=1,table.getn(debuff_curse_list) do
		self.options.args.debuff_menu.args.debuff_curse_options.args[debuff_curse] = {}
		self.options.args.debuff_menu.args.debuff_curse_options.args[debuff_curse] = {
			type  = 'group',
			name  = debuff_curse_list[debuff_curse],
			desc  = debuff_curse_list[debuff_curse],
			args  = {},
		}
	end
		
	--rebuild debuff_curse options
	for debuff_curse=1,table.getn(debuff_curse_list) do
		
		--raid/group
		self.options.args.debuff_menu.args.debuff_curse_options.args[debuff_curse].args[1] = {
		type = 'toggle',
		order = 2,
		name = L["opt_name_raidparty"],
		desc = L["opt_desc_raidparty"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_curse_list[debuff_curse])].raid
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(debuff_curse_list[debuff_curse])].raid = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_curse_list[debuff_curse])].raid
		      end,
		}
		
		--say
		self.options.args.debuff_menu.args.debuff_curse_options.args[debuff_curse].args[2] = {
		type = 'toggle',
		order = 1,
		name = L["opt_name_say"],
		desc = L["opt_desc_say"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_curse_list[debuff_curse])].say
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(debuff_curse_list[debuff_curse])].say = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_curse_list[debuff_curse])].say
		      end,
		}
		
		--whisper (disabled for activation announcements)
		if (L:GetReverseTranslation(debuff_curse_list[debuff_curse]) ~= "Veil of Shadow") and 
		   (L:GetReverseTranslation(debuff_curse_list[debuff_curse]) ~= "Curse of Doom") and 
		   (L:GetReverseTranslation(debuff_curse_list[debuff_curse]) ~= "Cursed Arrow") then
			OptiTaunt.options.args.debuff_curse_options.args[debuff_curse].args[3] = {
				type = 'toggle',
				order = 4,
				name = L["opt_name_autowhisper"],
				desc = L["opt_desc_autowhisper"],
				get = function()
						return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_curse_list[debuff_curse])].whisper
					  end,
				set = function()
						self.db.profile.outputsettings[L:GetReverseTranslation(debuff_curse_list[debuff_curse])].whisper = 
						not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_curse_list[debuff_curse])].whisper
					  end,
				}
		else
			self.options.args.debuff_menu.args.debuff_curse_options.args[debuff_curse].args[3] = nil
		end
		
		--Raidwarning
		self.options.args.debuff_menu.args.debuff_curse_options.args[debuff_curse].args[4] = {
		type = 'toggle',
		order = 3,
		name = L["opt_name_raidwarning"],
		desc = L["opt_desc_raidwarning"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_curse_list[debuff_curse])].raidwarning
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(debuff_curse_list[debuff_curse])].raidwarning = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_curse_list[debuff_curse])].raidwarning
		      end,
		}
		
		--custom channels
		for i=5,table.getn(self.channels)/2+4 do
			self.options.args.debuff_menu.args.debuff_curse_options.args[debuff_curse].args[i] = {
				type = 'toggle',
				name = self.channels[(i-4)*2],
				desc = self.channels[(i-4)*2],
			
				get = 	function()
							local rc = false
							for j=1,table.getn(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_curse_list[debuff_curse])].channel) do
								if self.db.profile.outputsettings[L:GetReverseTranslation(debuff_curse_list[debuff_curse])].channel[j] == self.channels[(i-4)*2] then 
									rc = true 
								end
							end
							return rc
						end,
				set = 	function()
							local deletion = false
							for j=1,table.getn(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_curse_list[debuff_curse])].channel) do
								if self.db.profile.outputsettings[L:GetReverseTranslation(debuff_curse_list[debuff_curse])].channel[j] == self.channels[(i-4)*2] then
									table.remove(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_curse_list[debuff_curse])].channel, j)
									deletion=true
								end
							end
							if not deletion then
								table.insert(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_curse_list[debuff_curse])].channel, self.channels[(i-4)*2])
							end
						end,
				}
		end
	end
end

-- Poison (Tank debuff) list creation, content is provided by 'OnInitialize()'
function OptiTaunt:CreateOutputSettings7(debuff_poison_list)

	--
	local debuff_poison, activate
	self.channels = {GetChannelList()}
	self.options.args.debuff_menu.args.debuff_poison_options.args = {}
				
	--rebuild debuff_poisons
	for debuff_poison=1,table.getn(debuff_poison_list) do
		self.options.args.debuff_menu.args.debuff_poison_options.args[debuff_poison] = {}
		self.options.args.debuff_menu.args.debuff_poison_options.args[debuff_poison] = {
			type  = 'group',
			name  = debuff_poison_list[debuff_poison],
			desc  = debuff_poison_list[debuff_poison],
			args  = {},
		}
	end
		
	--rebuild debuff_poison options
	for debuff_poison=1,table.getn(debuff_poison_list) do
		
		--raid/group
		self.options.args.debuff_menu.args.debuff_poison_options.args[debuff_poison].args[1] = {
		type = 'toggle',
		order = 2,
		name = L["opt_name_raidparty"],
		desc = L["opt_desc_raidparty"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_poison_list[debuff_poison])].raid
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(debuff_poison_list[debuff_poison])].raid = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_poison_list[debuff_poison])].raid
		      end,
		}
		
		--say
		self.options.args.debuff_menu.args.debuff_poison_options.args[debuff_poison].args[2] = {
		type = 'toggle',
		order = 1,
		name = L["opt_name_say"],
		desc = L["opt_desc_say"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_poison_list[debuff_poison])].say
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(debuff_poison_list[debuff_poison])].say = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_poison_list[debuff_poison])].say
		      end,
		}
		
		--whisper (disabled for activation announcements)
		if (L:GetReverseTranslation(debuff_poison_list[debuff_poison]) ~= "Blinding Dirt") and 
		   (L:GetReverseTranslation(debuff_poison_list[debuff_poison]) ~= "Deadly Poison") then
			OptiTaunt.options.args.debuff_poison_options.args[debuff_poison].args[3] = {
				type = 'toggle',
				order = 4,
				name = L["opt_name_autowhisper"],
				desc = L["opt_desc_autowhisper"],
				get = function()
						return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_poison_list[debuff_poison])].whisper
					  end,
				set = function()
						self.db.profile.outputsettings[L:GetReverseTranslation(debuff_poison_list[debuff_poison])].whisper = 
						not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_poison_list[debuff_poison])].whisper
					  end,
				}
		else
			self.options.args.debuff_menu.args.debuff_poison_options.args[debuff_poison].args[3] = nil
		end
		
		--Raidwarning
		self.options.args.debuff_menu.args.debuff_poison_options.args[debuff_poison].args[4] = {
		type = 'toggle',
		order = 3,
		name = L["opt_name_raidwarning"],
		desc = L["opt_desc_raidwarning"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_poison_list[debuff_poison])].raidwarning
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(debuff_poison_list[debuff_poison])].raidwarning = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_poison_list[debuff_poison])].raidwarning
		      end,
		}
		
		--custom channels
		for i=5,table.getn(self.channels)/2+4 do
			self.options.args.debuff_menu.args.debuff_poison_options.args[debuff_poison].args[i] = {
				type = 'toggle',
				name = self.channels[(i-4)*2],
				desc = self.channels[(i-4)*2],
			
				get = 	function()
							local rc = false
							for j=1,table.getn(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_poison_list[debuff_poison])].channel) do
								if self.db.profile.outputsettings[L:GetReverseTranslation(debuff_poison_list[debuff_poison])].channel[j] == self.channels[(i-4)*2] then 
									rc = true 
								end
							end
							return rc
						end,
				set = 	function()
							local deletion = false
							for j=1,table.getn(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_poison_list[debuff_poison])].channel) do
								if self.db.profile.outputsettings[L:GetReverseTranslation(debuff_poison_list[debuff_poison])].channel[j] == self.channels[(i-4)*2] then
									table.remove(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_poison_list[debuff_poison])].channel, j)
									deletion=true
								end
							end
							if not deletion then
								table.insert(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_poison_list[debuff_poison])].channel, self.channels[(i-4)*2])
							end
						end,
				}
		end
	end
end

-- Disease (Tank debuff) list creation, content is provided by 'OnInitialize()'
function OptiTaunt:CreateOutputSettings8(debuff_disease_list)

	--
	local debuff_disease, activate
	self.channels = {GetChannelList()}
	self.options.args.debuff_menu.args.debuff_disease_options.args = {}
				
	--rebuild debuff_diseases
	for debuff_disease=1,table.getn(debuff_disease_list) do
		self.options.args.debuff_menu.args.debuff_disease_options.args[debuff_disease] = {}
		self.options.args.debuff_menu.args.debuff_disease_options.args[debuff_disease] = {
			type  = 'group',
			name  = debuff_disease_list[debuff_disease],
			desc  = debuff_disease_list[debuff_disease],
			args  = {},
		}
	end
		
	--rebuild debuff_disease options
	for debuff_disease=1,table.getn(debuff_disease_list) do
		
		--raid/group
		self.options.args.debuff_menu.args.debuff_disease_options.args[debuff_disease].args[1] = {
		type = 'toggle',
		order = 2,
		name = L["opt_name_raidparty"],
		desc = L["opt_desc_raidparty"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_disease_list[debuff_disease])].raid
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(debuff_disease_list[debuff_disease])].raid = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_disease_list[debuff_disease])].raid
		      end,
		}
		
		--say
		self.options.args.debuff_menu.args.debuff_disease_options.args[debuff_disease].args[2] = {
		type = 'toggle',
		order = 1,
		name = L["opt_name_say"],
		desc = L["opt_desc_say"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_disease_list[debuff_disease])].say
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(debuff_disease_list[debuff_disease])].say = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_disease_list[debuff_disease])].say
		      end,
		}
		
		--whisper (disabled for activation announcements)
		if (L:GetReverseTranslation(debuff_disease_list[debuff_disease]) ~= "Leeching Rot") and 
		   (L:GetReverseTranslation(debuff_disease_list[debuff_disease]) ~= "Blight") then
			OptiTaunt.options.args.debuff_disease_options.args[debuff_disease].args[3] = {
				type = 'toggle',
				order = 4,
				name = L["opt_name_autowhisper"],
				desc = L["opt_desc_autowhisper"],
				get = function()
						return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_disease_list[debuff_disease])].whisper
					  end,
				set = function()
						self.db.profile.outputsettings[L:GetReverseTranslation(debuff_disease_list[debuff_disease])].whisper = 
						not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_disease_list[debuff_disease])].whisper
					  end,
				}
		else
			self.options.args.debuff_menu.args.debuff_disease_options.args[debuff_disease].args[3] = nil
		end
		
		--Raidwarning
		self.options.args.debuff_menu.args.debuff_disease_options.args[debuff_disease].args[4] = {
		type = 'toggle',
		order = 3,
		name = L["opt_name_raidwarning"],
		desc = L["opt_desc_raidwarning"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(debuff_disease_list[debuff_disease])].raidwarning
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(debuff_disease_list[debuff_disease])].raidwarning = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(debuff_disease_list[debuff_disease])].raidwarning
		      end,
		}
		
		--custom channels
		for i=5,table.getn(self.channels)/2+4 do
			self.options.args.debuff_menu.args.debuff_disease_options.args[debuff_disease].args[i] = {
				type = 'toggle',
				name = self.channels[(i-4)*2],
				desc = self.channels[(i-4)*2],
			
				get = 	function()
							local rc = false
							for j=1,table.getn(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_disease_list[debuff_disease])].channel) do
								if self.db.profile.outputsettings[L:GetReverseTranslation(debuff_disease_list[debuff_disease])].channel[j] == self.channels[(i-4)*2] then 
									rc = true 
								end
							end
							return rc
						end,
				set = 	function()
							local deletion = false
							for j=1,table.getn(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_disease_list[debuff_disease])].channel) do
								if self.db.profile.outputsettings[L:GetReverseTranslation(debuff_disease_list[debuff_disease])].channel[j] == self.channels[(i-4)*2] then
									table.remove(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_disease_list[debuff_disease])].channel, j)
									deletion=true
								end
							end
							if not deletion then
								table.insert(self.db.profile.outputsettings[L:GetReverseTranslation(debuff_disease_list[debuff_disease])].channel, self.channels[(i-4)*2])
							end
						end,
				}
		end
	end
end

-- Heal requiring debuff list creation, content is provided by 'OnInitialize()'
function OptiTaunt:CreateOutputSettings9(healreq_list)

	--
	local healreq, activate
	self.channels = {GetChannelList()}
	self.options.args.debuff_menu.args.healreq_options.args = {}
				
	--rebuild healreqs
	for healreq=1,table.getn(healreq_list) do
		self.options.args.debuff_menu.args.healreq_options.args[healreq] = {}
		self.options.args.debuff_menu.args.healreq_options.args[healreq] = {
			type  = 'group',
			name  = healreq_list[healreq],
			desc  = healreq_list[healreq],
			args  = {},
		}
	end
		
	--rebuild healreq options
	for healreq=1,table.getn(healreq_list) do
		
		--raid/group
		self.options.args.debuff_menu.args.healreq_options.args[healreq].args[1] = {
		type = 'toggle',
		order = 2,
		name = L["opt_name_raidparty"],
		desc = L["opt_desc_raidparty"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(healreq_list[healreq])].raid
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(healreq_list[healreq])].raid = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(healreq_list[healreq])].raid
		      end,
		}
		
		--say
		self.options.args.debuff_menu.args.healreq_options.args[healreq].args[2] = {
		type = 'toggle',
		order = 1,
		name = L["opt_name_say"],
		desc = L["opt_desc_say"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(healreq_list[healreq])].say
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(healreq_list[healreq])].say = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(healreq_list[healreq])].say
		      end,
		}
		
		--whisper (disabled for activation announcements)
		if (L:GetReverseTranslation(healreq_list[healreq]) ~= "Glacial Strike") then
			OptiTaunt.options.args.healreq_options.args[healreq].args[3] = {
				type = 'toggle',
				order = 4,
				name = L["opt_name_autowhisper"],
				desc = L["opt_desc_autowhisper"],
				get = function()
						return self.db.profile.outputsettings[L:GetReverseTranslation(healreq_list[healreq])].whisper
					  end,
				set = function()
						self.db.profile.outputsettings[L:GetReverseTranslation(healreq_list[healreq])].whisper = 
						not self.db.profile.outputsettings[L:GetReverseTranslation(healreq_list[healreq])].whisper
					  end,
				}
		else
			self.options.args.debuff_menu.args.healreq_options.args[healreq].args[3] = nil
		end
		
		--Raidwarning
		self.options.args.debuff_menu.args.healreq_options.args[healreq].args[4] = {
		type = 'toggle',
		order = 3,
		name = L["opt_name_raidwarning"],
		desc = L["opt_desc_raidwarning"],
		get = function()
				return self.db.profile.outputsettings[L:GetReverseTranslation(healreq_list[healreq])].raidwarning
			  end,
		set = function()
			    self.db.profile.outputsettings[L:GetReverseTranslation(healreq_list[healreq])].raidwarning = 
				not self.db.profile.outputsettings[L:GetReverseTranslation(healreq_list[healreq])].raidwarning
		      end,
		}
		
		--custom channels
		for i=5,table.getn(self.channels)/2+4 do
			self.options.args.debuff_menu.args.healreq_options.args[healreq].args[i] = {
				type = 'toggle',
				name = self.channels[(i-4)*2],
				desc = self.channels[(i-4)*2],
			
				get = 	function()
							local rc = false
							for j=1,table.getn(self.db.profile.outputsettings[L:GetReverseTranslation(healreq_list[healreq])].channel) do
								if self.db.profile.outputsettings[L:GetReverseTranslation(healreq_list[healreq])].channel[j] == self.channels[(i-4)*2] then 
									rc = true 
								end
							end
							return rc
						end,
				set = 	function()
							local deletion = false
							for j=1,table.getn(self.db.profile.outputsettings[L:GetReverseTranslation(healreq_list[healreq])].channel) do
								if self.db.profile.outputsettings[L:GetReverseTranslation(healreq_list[healreq])].channel[j] == self.channels[(i-4)*2] then
									table.remove(self.db.profile.outputsettings[L:GetReverseTranslation(healreq_list[healreq])].channel, j)
									deletion=true
								end
							end
							if not deletion then
								table.insert(self.db.profile.outputsettings[L:GetReverseTranslation(healreq_list[healreq])].channel, self.channels[(i-4)*2])
							end
						end,
				}
		end
	end
end


-- Tooltip generation (taunt statistics)
function OptiTaunt:OnTooltipUpdate()
	
	if (self.tauntresistcount == 0) then
		self.tauntresistpercent = 0
	else
		self.tauntresistpercent = math.floor((self.tauntresistcount / self.tauntcount) * 10000)/100
	end
		
	tablet:SetHint(L["Tooltip"])
	
	local cat = tablet:AddCategory(
       'text', L["Statistics"],
       'columns', 2,
       'child_textR', 1,
       'child_textG', 1,
       'child_textB', 0,
       'child_textR2', 1,
       'child_textG2', 1,
       'child_textB2', 1
   )
   
   cat:AddLine(
       'text', L["Taunts"],
       'text2', self.tauntcount
   )
   
   cat:AddLine(
       'text', L["Resisted"],
       'text2', self.tauntresistcount.." ("..self.tauntresistpercent.."%)"
   ) 
    
end


function OptiTaunt:CHANNEL_UI_UPDATE()
	
	OptiTaunt:dbg("---Entering OptiTaunt:CHANNEL_UI_UPDATE---")
	OptiTaunt:CreateOutputSettings(self.ability_list)

end


-- Combat Log Events
function OptiTaunt:COMBAT_LOG_EVENT_UNFILTERED(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, ...)
	
	-- see http://www.wowwiki.com/API_COMBAT_LOG_EVENT#Examples
	
	--debug stuff
	--[[local message = format("%s> %s, %s, %s, %s, %s, %s, %s",
	                       timestamp, eventtype, srcGUID, srcName or "nil", srcFlags or "nil", dstGUID, dstName or "nil", dstFlags or "nil");
	for i = 9, select("#", ...) do
		message = message..", "..(select(i, ...) or "nil");
	end
	OptiTaunt:dbg(message)]]
	
	if (eventtype == "SPELL_MISSED") and (srcGUID == UnitGUID("player")) then
		OptiTaunt:Spell_Missed(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags,...)
	end
	
	if (eventtype == "SPELL_CAST_SUCCESS") and (srcGUID == UnitGUID("player")) then
		OptiTaunt:Spell_Cast_Success(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags,...)
	end
	
	if (eventtype == "SPELL_INTERRUPT") and (srcGUID == UnitGUID("player")) then
		OptiTaunt:Spell_Interrupt(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags,...)
	end
	
	if (eventtype == "SPELL_AURA_REMOVED") and (srcGUID == UnitGUID("player")) then
		OptiTaunt:Spell_Aura_Removed(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags,...)
	end
	
	--Player-Debuffs
	if (eventtype == "SPELL_AURA_APPLIED") and (arg7 == UnitName("Player")) then
		OptiTaunt:Debuff_Self_Applied(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags,...)
	end
	
	if (eventtype == "SPELL_AURA_REMOVED") and (arg7 == UnitName("Player")) then
		OptiTaunt:Debuff_Self_End(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags,...)
	end

end


-- this is were we actually check for resisted/immune taunts or resisted/immune/avoided interrupts and decide wether to report them or not
function OptiTaunt:Spell_Missed(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool, missType)
	
	OptiTaunt:dbg("---Entering OptiTaunt:Spell_Missed---")
	
	--if (missType == "MISS") or (missType == "IMMUNE") then
	
	OptiTaunt:dbg("missType: "..missType)
	OptiTaunt:dbg("spellName: "..spellName)
	
	--check for taunt abilities
		if (spellId == 355) --Taunt
		or (spellId == 6795) --Growl
		or (spellId == 694) --Mocking Blow
		or (spellId == 31789) --Righteous Defense
		or (spellId == 62124) --Hand of Reckoning
		--or ((spellId == 26985) and self.isDebug) --Wrath (for testing)
		or (spellId == 31935) or (spellId == 32699) or (spellId == 32700) or (spellId == 48826) or (spellId == 48827) --Avenger's Shield
		or (spellId == 56222) --Dark Command / Dunkler Befehl
		or (spellId == 49576) --Death Grip / Todesgriff
		then 
			
			local doAlert=true
			
			--when aggrocheck is enabled we have to check if we already have aggro
			if (self.db.profile.aggroCheck) and (UnitIsUnit("player","targettarget")) then
				doAlert=false
			end
			
			--when pvpcheck is enabled we check if our target is another player
			if (self.db.profile.pvpCheck) and (UnitPlayerControlled("target")) then
				doAlert=false
			end
			
			--if all checks were successful we give an alert
			if (doAlert) then
				if (missType == "MISS") then
					self.tauntresistcount = self.tauntresistcount + 1
					if self.db.profile.announceresist then 
						OptiTaunt:giveAlert(spellName, dstName, missType)
						OptiTaunt:giveAudioAlert()
					end
				elseif (missType == "IMMUNE" and self.db.profile.announceimmune) then
					OptiTaunt:giveAlert(spellName, dstName, missType)
					OptiTaunt:giveAudioAlert()
				end
			end
		end
		
	--check for disarm
		if (spellId == 676) --Disarm (Warrior)
		then
			local doAlert=true
			
			--when pvpcheck is enabled we check if our target is another player
			if (self.db.profile.pvpCheck) and (UnitPlayerControlled("target")) then
				doAlert=false
			end
			
			if (doAlert) then
				if ((missType == "MISS") or (missType == "DEFLECT") or (missType == "REFLECT") or (missType == "BLOCK") or (missType == "DODGE") or (missType == "EVADE") or (missType == "PARRY") or (missType == "RESIST")) then
					if self.db.profile.announceresist then 
						OptiTaunt:giveAlert(spellName, dstName, "MISS")
						--OptiTaunt:giveAudioAlert()
					end
				elseif (missType == "IMMUNE" and self.db.profile.announceimmune) then
					OptiTaunt:giveAlert(spellName, dstName, missType)
					--OptiTaunt:giveAudioAlert()
				end
			end
		end
		
	--check for interrupt abilities
		if (spellId == 72) --Shield Bash
		or (spellId == 6552) --Pummel
		or (spellId == 47476) --Strangulate
		then
			local doAlert=true
			
			--when pvpcheck is enabled we check if our target is another player
			if (self.db.profile.pvpCheck) and (UnitPlayerControlled("target")) then
				doAlert=false
			end
			
			if (doAlert) then
				if ((missType == "MISS") or (missType == "DEFLECT") or (missType == "REFLECT") or (missType == "BLOCK") or (missType == "DODGE") or (missType == "EVADE") or (missType == "PARRY") or (missType == "RESIST")) then
					if self.db.profile.announceresist then 
						OptiTaunt:giveAlert(spellName, dstName, "MISS")
						--OptiTaunt:giveAudioAlert()
					end
				elseif (missType == "IMMUNE" and self.db.profile.announceimmune) then
					OptiTaunt:giveAlert(spellName, dstName, missType)
					--OptiTaunt:giveAudioAlert()
				end
			end
		end
		
	--end
	OptiTaunt:dbg("---Leaving OptiTaunt:Spell_Missed---")
end

-- Use of Taunts and Abilities
function OptiTaunt:Spell_Cast_Success(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool)
	
	OptiTaunt:dbg("---Entering OptiTaunt:Spell_Cast_Success---")
	
--- WARRIOR

	--Taunt
	if (spellId == 355) then
		self.tauntcount = self.tauntcount + 1
	end	
	
	--Mocking Blow
	if (spellId == 694) then
		self.tauntcount = self.tauntcount + 1
	end
	
--- PALADIN
	
	--Avenger's Shield
	if (spellId == 31935) or (spellId == 32699) or (spellId == 32700) or (spellId == 48826) or (spellId == 48827) then
		self.tauntcount = self.tauntcount + 1
	end
	
	--Righteous Defense
	if (spellId == 31789) then
		self.tauntcount = self.tauntcount + 1
	end	
	
	--Hand of Reckoning
	if (spellId == 62124) then
		self.tauntcount = self.tauntcount + 1
	end
	
--- DRUID
	
	--Growl
	if (spellId == 6795) then
		self.tauntcount = self.tauntcount + 1
	end
	
--- DEATHKNIGHT
	
	--Dark Command
	if (spellId == 56222) then
		self.tauntcount = self.tauntcount + 1
	end
	
	--Death Grip
	if (spellId == 49576) then
		self.tauntcount = self.tauntcount + 1
	end
	
	
		
--- Announcements of special abilities

--- WARRIOR

	--Shield Wall
	if (spellId == 871) then
		self.abilityduration="12"
		if (self.db.profile.announceability) then
			OptiTaunt:giveAlert(spellName, _, "ABILITY")
		end
	end
	
	--Last Stand
	if (spellId == 12975) then
		self.abilityduration="20"
		if (self.db.profile.announceability) then
			OptiTaunt:giveAlert(spellName, _, "ABILITY")
		end
	end
	
	--Challenging Shout
	if (spellId == 1161) then
		self.abilityduration="10"
		if (self.db.profile.announceability) then
			OptiTaunt:giveAlert(spellName, _, "ABILITY")
			OptiTaunt:Timer(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool)
		end
	end
	
	--Enraged Regeneration
	if (spellId == 55694) then
		self.abilityduration="10"
		if (self.db.profile.announceability) then
			OptiTaunt:giveAlert(spellName, _, "ABILITY")
		end
	end
	
	--Disarm
	if (spellId == 676) then
		self.abilityduration="10"
		if (self.db.profile.announceability) then
			if (arg2 == "SPELL_CAST_SUCCESS") then
				OptiTaunt:giveAlert(spellName, dstName, "ABILITYONTARGET")
			end
		end
	end
	
	--Shield Bash
	if (spellId == 72) then
		self.abilityduration="6"
		if (self.db.profile.announceability) then
			if (arg2 == "SPELL_INTERRUPT") then
				OptiTaunt:giveAlert(dstName, extraSpellName, "COUNTERSPELL")
			end
		end
	end
	
	--Pummel
	if (spellId == 6552) then
		self.abilityduration="4"
		if (self.db.profile.announceability) then
			if (arg2 == "SPELL_INTERRUPT") then
				OptiTaunt:giveAlert(dstName, extraSpellName, "COUNTERSPELL")
			end
		end
	end
	
--- PALADIN

	--Divine Protection
	if (spellId == 498) then
		self.abilityduration="12"
		if (self.db.profile.announceability) then
			OptiTaunt:giveAlert(spellName, _, "ABILITY")
		end
	end
	
	--Ardent Defender
	if (spellId == 66235) then
		self.abilityduration="0"
		if (self.db.profile.announceability) then
			OptiTaunt:giveAlert(spellName, _, "PROC")
		end
	end
	
	
--- DRUID

	--Frenzied Regeneration
	if (spellId == 22842) then
		self.abilityduration="10"
		if (self.db.profile.announceability) then
			OptiTaunt:giveAlert(spellName, _, "ABILITY")
		end
	end
		
	--Survival Instincts
	if (spellId == 50322) or (spellId == 61336) then
		self.abilityduration="20"
		if (self.db.profile.announceability) then
			OptiTaunt:giveAlert(spellName, _, "ABILITY")
		end
	end
	
	--Challenging Roar
	if (spellId == 5209) then
		self.abilityduration="6"
		if (self.db.profile.announceability) then
			OptiTaunt:giveAlert(spellName, _, "ABILITY")
			OptiTaunt:Timer(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool)
		end
	end
	
	--Barkskin 
	if (spellId == 22812) and (GetShapeshiftForm(true) == 1) then
		self.abilityduration="12"
		if (self.db.profile.announceability) then
			OptiTaunt:giveAlert(spellName, _, "ABILITY")
		end
	end
	
--- DEATHKNIGHT

	--Vampiric Blood
	if (spellId == 55233) then
		self.abilityduration="10"
		if (self.db.profile.announceability) then
			OptiTaunt:giveAlert(spellName, _, "ABILITY")
		end
	end
	
	--Icebound Fortitude
	if (spellId == 48792) then
		self.abilityduration="12"
		if (self.db.profile.announceability) then
			OptiTaunt:giveAlert(spellName, _, "ABILITY")
		end
	end
	
	--Anti-Magic Shell
	if (spellId == 48707) then
		self.abilityduration="5"
		if (self.db.profile.announceability) then
			OptiTaunt:giveAlert(spellName, _, "ABILITY")
		end
	end
	
	--Unbreakable Armor
	if (spellId == 51271) then
		self.abilityduration="20"
		if (self.db.profile.announceability) then
			OptiTaunt:giveAlert(spellName, _, "ABILITY")
		end
	end	
	
	--Strangulate
	if (spellId == 47476) then
		self.abilityduration="3"
		if (self.db.profile.announceability) then
			if (arg2 == "SPELL_INTERRUPT") then
				OptiTaunt:giveAlert(dstName, extraSpellName, "COUNTERSPELL")
			end
		end
	end

	OptiTaunt:dbg("---Leaving OptiTaunt:Spell_Cast_Success---")
end	

-- End of Abilities -- AE-Taunts now handled via timer triggered by 'Spell_Cast_Success' - see function 'OptiTaunt:Timer'
function OptiTaunt:Spell_Aura_Removed(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool)

	OptiTaunt:dbg("---Entering OptiTaunt:Spell_Aura_Removed---")

--- WARRIOR

	--Shield Wall
	if (spellId == 871) then
		self.abilityduration="12"
		if (self.db.profile.announceability) and (self.db.profile.announceabilityend) then
			OptiTaunt:giveAlert(spellName, _, "ABILITYENDS")
		end
	end
	
	--Last Stand
	if (spellId == 12976) then
		self.abilityduration="20"
		if (self.db.profile.announceability) and (self.db.profile.announceabilityend) then
			OptiTaunt:giveAlert(spellName, _, "ABILITYENDS")
		end
	end
	
	--Challenging Shout
	--[[if (spellId == 1161) then
		self.abilityduration="6"
		if (self.db.profile.announceability) and (self.db.profile.announceabilityend) then
			OptiTaunt:giveAlert(spellName, _, "ABILITYENDS")
		end
	end]]
	
	--Enraged Regeneration
	if (spellId == 55694) then
		self.abilityduration="10"
		if (self.db.profile.announceability) and (self.db.profile.announceabilityend) then
			OptiTaunt:giveAlert(spellName, _, "ABILITYENDS")
		end
	end
	
	--Disarm
	if (spellId == 676) then
		self.abilityduration="10"
		if (self.db.profile.announceability) and (self.db.profile.announceabilityend) then
			OptiTaunt:giveAlert(spellName, dstName, "ABILITYONTARGETENDS")
		end
	end
	
--- PALADIN

	--Divine Protection
	if (spellId == 498) then
		self.abilityduration="12"
		if (self.db.profile.announceability) and (self.db.profile.announceabilityend) then
			OptiTaunt:giveAlert(spellName, _, "ABILITYENDS")
		end
	end
	
	
--- DRUID

	--Frenzied Regeneration
	if (spellId == 22842) then
		self.abilityduration="10"
		if (self.db.profile.announceability) and (self.db.profile.announceabilityend) then
			OptiTaunt:giveAlert(spellName, _, "ABILITYENDS")
		end
	end
		
	--Survival Instincts
	if (spellId == 50322) or (spellId == 61336) then
		self.abilityduration="20"
		if (self.db.profile.announceability) and (self.db.profile.announceabilityend) then
			OptiTaunt:giveAlert(spellName, _, "ABILITYENDS")
		end
	end
	
	--Challenging Roar
	--[[if (spellId == 5209) then
		self.abilityduration="6"
		if (self.db.profile.announceability) and (self.db.profile.announceabilityend) then
			OptiTaunt:giveAlert(spellName, _, "ABILITYENDS")
		end
	end]]
	
	--Barkskin 
	if (spellId == 22812) and (GetShapeshiftForm(true) == 1) then
		self.abilityduration="12"
		if (self.db.profile.announceability) and (self.db.profile.announceabilityend) then
			OptiTaunt:giveAlert(spellName, _, "ABILITYENDS")
		end
	end
	
--- DEATHKNIGHT

	--Vampiric Blood
	if (spellId == 55233) then
		self.abilityduration="10"
		if (self.db.profile.announceability) and (self.db.profile.announceabilityend) then
			OptiTaunt:giveAlert(spellName, _, "ABILITYENDS")
		end
	end
	
	--Icebound Fortitude
	if (spellId == 48792) then
		self.abilityduration="12"
		if (self.db.profile.announceability) and (self.db.profile.announceabilityend) then
			OptiTaunt:giveAlert(spellName, _, "ABILITYENDS")
		end
	end
	
	--Anti-Magic Shell
	if (spellId == 48707) then
		self.abilityduration="5"
		if (self.db.profile.announceability) and (self.db.profile.announceabilityend) then
			OptiTaunt:giveAlert(spellName, _, "ABILITYENDS")
		end
	end
	
	--Unbreakable Armor
	if (spellId == 51271) then
		self.abilityduration="20"
		if (self.db.profile.announceability) and (self.db.profile.announceabilityend) then
			OptiTaunt:giveAlert(spellName, _, "ABILITYENDS")
		end
	end

	OptiTaunt:dbg("---Leaving OptiTaunt:Spell_Aura_Removed---")
end

-- Successfull Interrupt
function OptiTaunt:Spell_Interrupt(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool, extraSpellID, extraSpellName)
	
	OptiTaunt:dbg("---Entering OptiTaunt:Spell_Interrupt---")
	
--- WARRIOR
	
	--Shield Bash
	if (spellId == 72) then
		self.abilityduration="6"
		if (self.db.profile.announceability) then
				OptiTaunt:giveAlert(extraSpellName, dstName, "COUNTERSPELL")
		end
	end
	
	--Pummel
	if (spellId == 6552) then
		self.abilityduration="4"
		if (self.db.profile.announceability) then
				OptiTaunt:giveAlert(extraSpellName, dstName, "COUNTERSPELL")
		end
	end
	
--- DEATHKNIGHT

	--Strangulate
	if (spellId == 47476) then
		self.abilityduration="3"
		if (self.db.profile.announceability) then
				OptiTaunt:giveAlert(extraSpellName, dstName, "COUNTERSPELL")
		end
	end
	
end

-- If a Debuff is applied on the Tank
function OptiTaunt:Debuff_Self_Applied(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool)

	OptiTaunt:dbg("---Entering OptiTaunt:Spell_Aura_Applied---")
	
--DISARMS
	--Disarm
	if (spellId == 676) and (arg7 == UnitName("Player")) then
		self.abilityduration="10"
		if (self.db.profile.announcedisarm) then
			OptiTaunt:giveAlert(spellName, _, "DISARM")
		end
	end
	
	--Dismantle
	if (spellId == 51722) and (arg7 == UnitName("Player")) then
		self.abilityduration="10"
		if (self.db.profile.announcedisarm) then
			OptiTaunt:giveAlert(spellName, _, "DISARM")
		end
	end
	
	--Chimera Shot - Scorpid
	if (spellId == 53359) and (arg7 == UnitName("Player")) then
		self.abilityduration="10"
		if (self.db.profile.announcedisarm) then
			OptiTaunt:giveAlert(spellName, _, "DISARM")
		end
	end
	
--[[
---- DEBUFFS --------------------------------------------------------------------------------------
]]

--Debuff
	--Delirious Slash	(Icecrown Citadel)
	if ((spellId == 71623) or (spellId == 71624) or (spellId == 71625) or (spellId == 71626)) and (arg7 == UnitName("Player")) then
		self.abilityduration="15"
		if (self.db.profile.announcedebuff) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFF")
		end
	end
	
	--Rune of Blood	(Icecrown Citadel)
	if ((spellId == 72408) or (spellId == 72409) or (spellId == 72410) or (spellId == 72447) or (spellId == 72448) or (spellId == 72449)) and (arg7 == UnitName("Player")) then
		self.abilityduration="20"
		if (self.db.profile.announcedebuff) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFF")
		end
	end
	
	--Necrotic Strike	(Icecrown Citadel)
	if ((spellId == 70659) or (spellId == 71951) or (spellId == 72490) or (spellId == 72491) or (spellId == 72492)) and (arg7 == UnitName("Player")) then
		self.abilityduration="20"
		if (self.db.profile.announcedebuff) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFF")
		end
	end
	
	--Rend Flesh	(Icecrown Citadel)
	if ((spellId == 70435) or (spellId == 71154)) and (arg7 == UnitName("Player")) then
		self.abilityduration="30"
		if (self.db.profile.announcedebuff) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFF")
		end
	end
	
	--Banish	(Icecrown Citadel)
	if (spellId == 71298) and (arg7 == UnitName("Player")) then
		self.abilityduration="6"
		if (self.db.profile.announcedebuff) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFF")
		end
	end
	
	--Black Brand	(Pit of Saron)
	if (spellId == 70392) and (arg7 == UnitName("Player")) then
		self.abilityduration="10"
		if (self.db.profile.announcedebuff) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFF")
		end
	end

--Stun
	--Blood Sap	(Icecrown Citadel)
	if (spellId == 70432) and (arg7 == UnitName("Player")) then
		self.abilityduration="8"
		if (self.db.profile.announcedebuff) then
			OptiTaunt:giveAlert(spellName, _, "STUN")
		end
	end

	--Shovelled!	(Pit of Saron)
	if ((spellId == 69572) or (spellId == 70280)) and (arg7 == UnitName("Player")) then
		self.abilityduration="3"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffstun) then
			OptiTaunt:giveAlert(spellName, _, "STUN")
		end
	end
	
	--Hoarfrost	(Pit of Saron)
	if ((spellId == 69245) or (spellId == 69645)) and (arg7 == UnitName("Player")) then
		self.abilityduration="5"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffstun) then
			OptiTaunt:giveAlert(spellName, _, "STUN")
		end
	end
	
	--Despair Stricken	(Halls of Reflection)
	if (spellId == 72428) and (arg7 == UnitName("Player")) then
		self.abilityduration="6"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffstun) then
			OptiTaunt:giveAlert(spellName, _, "STUN")
		end
	end
	
	--Kidney Shot	(Halls of Reflection)
	if (spellId == 72335) and (arg7 == UnitName("Player")) then
		self.abilityduration="3"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffstun) then
			OptiTaunt:giveAlert(spellName, _, "STUN")
		end
	end

--Magic
	--Polymorph: Spider	(Icecrown Citadel)
	if ((spellId == 70410) or (spellId == 72106)) and (arg7 == UnitName("Player")) then
		self.abilityduration="12"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffmagic) then
			OptiTaunt:giveAlert(spellName, _, "MAGIC")
		end
	end
	
	--Consuming Shadows	(Icecrown Citadel)
	if (spellId == 69405) and (arg7 == UnitName("Player")) then
		self.abilityduration="20"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffmagic) then
			OptiTaunt:giveAlert(spellName, _, "MAGIC")
		end
	end
	
	--Chains of Shadow	(Icecrown Citadel)
	if (spellId == 70645) and (arg7 == UnitName("Player")) then
		self.abilityduration="10"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffmagic) then
			OptiTaunt:giveAlert(spellName, _, "MAGIC")
		end
	end
	
	--Soul Sickness	(Forge of Souls)
	if (spellId == 69131) and (arg7 == UnitName("Player")) then
		self.abilityduration="8"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffmagic) then
			OptiTaunt:giveAlert(spellName, _, "MAGIC")
		end
	end
	
	--Impending Despair	(Halls of Reflection) --if not dispelled -> 72428 Despair Stricken (STUN)
	if (spellId == 72426) and (arg7 == UnitName("Player")) then
		self.abilityduration="6"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffmagic) then
			OptiTaunt:giveAlert(spellName, _, "MAGIC")
		end
	end
	
	--Shared Suffering	(Halls of Reflection)
	if ((spellId == 72368) or (spellId == 72369) or (spellId == 72373)) and (arg7 == UnitName("Player")) then
		self.abilityduration="12"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffmagic) then
			OptiTaunt:giveAlert(spellName, _, "MAGIC")
		end
	end
	
	--Chains of Ice	(Halls of Reflection)
	if (spellId == 72171) and (arg7 == UnitName("Player")) then
		self.abilityduration="6"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffmagic) then
			OptiTaunt:giveAlert(spellName, _, "MAGIC")
		end
	end
	
--Curse
	--Veil of Shadow	(Forge of Souls)
	if (spellId == 69633) and (arg7 == UnitName("Player")) then
		self.abilityduration="15"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffcurse) then
			OptiTaunt:giveAlert(spellName, _, "CURSE")
		end
	end
	
	--Curse of Doom	(Halls of Reflection)
	if ((spellId == 70144) or (spellId == 70183)) and (arg7 == UnitName("Player")) then
		self.abilityduration="10"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffcurse) then
			OptiTaunt:giveAlert(spellName, _, "CURSE")
		end
	end
	
	--Cursed Arrow	(Halls of Reflection)
	if (spellId == 72222) and (arg7 == UnitName("Player")) then
		self.abilityduration="10"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffcurse) then
			OptiTaunt:giveAlert(spellName, _, "CURSE")
		end
	end

--Poison
	--Blinding Dirt	(Pit of Saron)
	if (spellId == 70302) and (arg7 == UnitName("Player")) then
		self.abilityduration="3"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffpoison) then
			OptiTaunt:giveAlert(spellName, _, "POISON")
		end
	end
	
	--Deadly Poison	(Halls of Reflection)
	if ((spellId == 72329) or (spellId == 72330)) and (arg7 == UnitName("Player")) then
		self.abilityduration="12"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffpoison) then
			OptiTaunt:giveAlert(spellName, _, "POISON")
		end
	end

--Disease
	--Leeching Rot	(Icecrown Citadel)
	if ((spellId == 70671) or (spellId == 70710)) and (arg7 == UnitName("Player")) then
		self.abilityduration="9"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffdisease) then
			OptiTaunt:giveAlert(spellName, _, "DISEASE")
		end
	end

	--Blight	(Pit of Saron)
	if ((spellId == 69603) or (spellId == 70285)) and (arg7 == UnitName("Player")) then
		self.abilityduration="15"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffdisease) then
			OptiTaunt:giveAlert(spellName, _, "DISEASE")
		end
	end

--Heal req.
	--Glacial Strike	(Icecrown Citadel)
	if ((spellId == 71316) or (spellId == 71317)) and (arg7 == UnitName("Player")) then
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebufffullheal) then
			OptiTaunt:giveAlert(spellName, _, "HEALREQ")
		end
	end

	--Glacial Strike	(Pit of Saron)
	if (spellId == 70292) and (arg7 == UnitName("Player")) then
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebufffullheal) then
			OptiTaunt:giveAlert(spellName, _, "HEALREQ")
		end
	end
	
	
	OptiTaunt:dbg("---Leaving OptiTaunt:Spell_Aura_Applied---")
end

-- A Tank Debuff ends
function OptiTaunt:Debuff_Self_End(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool)

	OptiTaunt:dbg("---Entering OptiTaunt:Debuff_Self_End---")
	
--DISARMS
	--Disarm
	if (spellId == 676) and (arg7 == UnitName("Player")) then
		self.abilityduration="10"
		if (self.db.profile.announcedisarm) and (self.db.profile.announcedisarmend) then
			OptiTaunt:giveAlert(spellName, _, "DISARMENDS")
		end
	end
	
	--Dismantle
	if (spellId == 51722) and (arg7 == UnitName("Player")) then
		self.abilityduration="10"
		if (self.db.profile.announcedisarm) and (self.db.profile.announcedisarmend) then
			OptiTaunt:giveAlert(spellName, _, "DISARMENDS")
		end
	end
	
	--Chimera Shot - Scorpid
	if (spellId == 53359) and (arg7 == UnitName("Player")) then
		self.abilityduration="10"
		if (self.db.profile.announcedisarm) and (self.db.profile.announcedisarmend) then
			OptiTaunt:giveAlert(spellName, _, "DISARMENDS")
		end
	end
	
--[[
---- DEBUFFS --------------------------------------------------------------------------------------
]]

--Debuff
	--Delirious Slash	(Icecrown Citadel)
	if ((spellId == 71623) or (spellId == 71624) or (spellId == 71625) or (spellId == 71626)) and (arg7 == UnitName("Player")) then
		self.abilityduration="15"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end
	
	--Rune of Blood	(Icecrown Citadel)
	if ((spellId == 72408) or (spellId == 72409) or (spellId == 72410) or (spellId == 72447) or (spellId == 72448) or (spellId == 72449)) and (arg7 == UnitName("Player")) then
		self.abilityduration="20"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end
	
	--Necrotic Strike	(Icecrown Citadel)
	if ((spellId == 70659) or (spellId == 71951) or (spellId == 72490) or (spellId == 72491) or (spellId == 72492)) and (arg7 == UnitName("Player")) then
		self.abilityduration="20"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end
	
	--Rend Flesh	(Icecrown Citadel)
	if ((spellId == 70435) or (spellId == 71154)) and (arg7 == UnitName("Player")) then
		self.abilityduration="30"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end
	
	--Banish	(Icecrown Citadel)
	if (spellId == 71298) and (arg7 == UnitName("Player")) then
		self.abilityduration="6"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end
	
	--Black Brand	(Pit of Saron)
	if (spellId == 70392) and (arg7 == UnitName("Player")) then
		self.abilityduration="10"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end

--Stun
	--Blood Sap	(Icecrown Citadel)
	if (spellId == 70432) and (arg7 == UnitName("Player")) then
		self.abilityduration="8"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end

	--Shovelled!	(Pit of Saron)
	if ((spellId == 69572) or (spellId == 70280)) and (arg7 == UnitName("Player")) then
		self.abilityduration="3"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebuffstun) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end
	
	--Hoarfrost	(Pit of Saron)
	if ((spellId == 69245) or (spellId == 69645)) and (arg7 == UnitName("Player")) then
		self.abilityduration="5"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebuffstun) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end
	
	--Despair Stricken	(Halls of Reflection)
	if (spellId == 72428) and (arg7 == UnitName("Player")) then
		self.abilityduration="6"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebuffstun) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end
	
	--Kidney Shot	(Halls of Reflection)
	if (spellId == 72335) and (arg7 == UnitName("Player")) then
		self.abilityduration="3"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebuffstun) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end

--Magic
	--Polymorph: Spider	(Icecrown Citadel)
	if ((spellId == 70410) or (spellId == 72106)) and (arg7 == UnitName("Player")) then
		self.abilityduration="12"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebuffmagic) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end
	
	--Consuming Shadows	(Icecrown Citadel)
	if (spellId == 69405) and (arg7 == UnitName("Player")) then
		self.abilityduration="20"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebuffmagic) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end
	
	--Chains of Shadow	(Icecrown Citadel)
	if (spellId == 70645) and (arg7 == UnitName("Player")) then
		self.abilityduration="10"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebuffmagic) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end
	
	--Soul Sickness	(Forge of Souls)
	if (spellId == 69131) and (arg7 == UnitName("Player")) then
		self.abilityduration="8"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebuffmagic) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end
	
	--Impending Despair	(Halls of Reflection) --if not dispelled -> 72428 Despair Stricken (STUN)
	if (spellId == 72426) and (arg7 == UnitName("Player")) then
		self.abilityduration="6"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebuffmagic) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end
	
	--Shared Suffering	(Halls of Reflection)
	if ((spellId == 72368) or (spellId == 72369) or (spellId == 72373)) and (arg7 == UnitName("Player")) then
		self.abilityduration="12"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebuffmagic) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end
	
	--Chains of Ice	(Halls of Reflection)
	if (spellId == 72171) and (arg7 == UnitName("Player")) then
		self.abilityduration="6"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebuffmagic) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end
	
--Curse
	--Veil of Shadow	(Forge of Souls)
	if (spellId == 69633) and (arg7 == UnitName("Player")) then
		self.abilityduration="15"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebuffcurse) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end
	
	--Curse of Doom	(Halls of Reflection)
	if ((spellId == 70144) or (spellId == 70183)) and (arg7 == UnitName("Player")) then
		self.abilityduration="10"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebuffcurse) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end
	
	--Cursed Arrow	(Halls of Reflection)
	if (spellId == 72222) and (arg7 == UnitName("Player")) then
		self.abilityduration="10"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebuffcurse) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end

--Poison
	--Blinding Dirt	(Pit of Saron)
	if (spellId == 70302) and (arg7 == UnitName("Player")) then
		self.abilityduration="3"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebuffpoison) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end
	
	--Deadly Poison	(Halls of Reflection)
	if ((spellId == 72329) or (spellId == 72330)) and (arg7 == UnitName("Player")) then
		self.abilityduration="12"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebuffpoison) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end

--Disease
	--Leeching Rot	(Icecrown Citadel)
	if ((spellId == 70671) or (spellId == 70710)) and (arg7 == UnitName("Player")) then
		self.abilityduration="9"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebuffdisease) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end

	--Blight	(Pit of Saron)
	if ((spellId == 69603) or (spellId == 70285)) and (arg7 == UnitName("Player")) then
		self.abilityduration="15"
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebuffdisease) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end

--Full Heal req.
	--Glacial Strike	(Icecrown Citadel)
	if ((spellId == 71316) or (spellId == 71317)) and (arg7 == UnitName("Player")) then
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebufffullheal) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end

	--Glacial Strike	(Pit of Saron)
	if (spellId == 70292) and (arg7 == UnitName("Player")) then
		if (self.db.profile.announcedebuff) and (self.db.profile.announcedebuffend) and (self.db.profile.announcedebufffullheal) then
			OptiTaunt:giveAlert(spellName, _, "DEBUFFENDS")
		end
	end
	
	
	OptiTaunt:dbg("---Leaving OptiTaunt:Debuff_Self_End---")
end

--Timer (for AoETaunt)
function OptiTaunt:Timer(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool)
_, self.playerclass	= UnitClass("player")

local frame = CreateFrame("Frame", "OptiTaunt");

	--Challenging Roar
	if (spellId == 5209) then
		if (self.playerclass == "DRUID") and (self.db.profile.announceability) and (self.db.profile.announceabilityend) then
		local d=6; u=GetTime()+d t=u
			frame:SetScript("OnUpdate",function() if GetTime()>=t then OptiTaunt:giveAlert(spellName, _, "ABILITYENDS");t=nil;frame:SetScript("OnUpdate",nil)end end)
		end
	end
	
	--Challenging Shout
	if (spellId == 1161) then
		if (self.playerclass == "WARRIOR") and (self.db.profile.announceability) and (self.db.profile.announceabilityend) then
		local d=6; u=GetTime()+d t=u
			frame:SetScript("OnUpdate",function() if GetTime()>=t then OptiTaunt:giveAlert(spellName, _, "ABILITYENDS");t=nil;frame:SetScript("OnUpdate",nil)end end)
		end
	end
	
end


-- Alert system
function OptiTaunt:giveAlert(ability,mob,msgtype)
	-- see http://www.wowwiki.com/API_gsub and http://www.wowwiki.com/HOWTO:_Use_Pattern_Matching
	
	-- parse warningmessage
	if (msgtype == "MISS") then
		self.warningmessage = string.gsub(string.gsub(self.db.profile.resistmessage, "{t}", mob), "{a}", ability)
	elseif (msgtype == "IMMUNE") then
		self.warningmessage = string.gsub(string.gsub(self.db.profile.immunemessage, "{t}", mob), "{a}", ability)
	elseif (msgtype == "ABILITY") then
		self.warningmessage = string.gsub(string.gsub(self.db.profile.abilitymessage, "{a}", ability), "{d}", self.abilityduration)
	elseif (msgtype == "ABILITYENDS") then
		self.warningmessage = string.gsub(string.gsub(self.db.profile.abilityendmessage, "{a}", ability))
	elseif (msgtype == "ABILITYONTARGET") then
		self.warningmessage = string.gsub(string.gsub(string.gsub(self.db.profile.abilityontargetmessage, "{a}", ability), "{t}", mob), "{d}", self.abilityduration)
	elseif (msgtype == "ABILITYONTARGETENDS") then
		self.warningmessage = string.gsub(string.gsub(self.db.profile.abilityontargetendmessage, "{a}", ability), "{t}", mob)
	elseif (msgtype == "INSTANTCAST") then
		self.warningmessage = string.gsub(string.gsub(self.db.profile.instantcastmessage, "{a}", ability), "{t}", mob)
	elseif (msgtype == "COUNTERSPELL") then
		self.warningmessage = string.gsub(string.gsub(string.gsub(self.db.profile.counterspellmessage, "{s}", ability), "{t}", mob), "{d}", self.abilityduration)
	elseif (msgtype == "PROC") then
		self.warningmessage = string.gsub(self.db.profile.procmessage, "{a}", ability)
	elseif (msgtype == "DISARM") then
		self.warningmessage = string.gsub(string.gsub(self.db.profile.disarmmessage, "{a}", ability), "{d}", self.abilityduration)
	elseif (msgtype == "DISARMENDS") then
		self.warningmessage = string.gsub(string.gsub(self.db.profile.disarmendmessage, "{a}", ability))
	elseif (msgtype == "DEBUFF") then
		self.warningmessage = string.gsub(string.gsub(self.db.profile.debuffmessage, "{a}", ability), "{d}", self.abilityduration)
	elseif (msgtype == "DEBUFFENDS") then
		self.warningmessage = string.gsub(string.gsub(self.db.profile.debuffendmessage, "{a}", ability))
	elseif (msgtype == "STUN") then
		self.warningmessage = string.gsub(string.gsub(self.db.profile.debuffstunmessage, "{a}", ability), "{d}", self.abilityduration)
	elseif (msgtype == "MAGIC") then
		self.warningmessage = string.gsub(string.gsub(self.db.profile.debuffmagicmessage, "{a}", ability), "{d}", self.abilityduration)
	elseif (msgtype == "CURSE") then
		self.warningmessage = string.gsub(string.gsub(self.db.profile.debuffcursemessage, "{a}", ability), "{d}", self.abilityduration)
	elseif (msgtype == "POISON") then
		self.warningmessage = string.gsub(string.gsub(self.db.profile.debuffpoisonmessage, "{a}", ability), "{d}", self.abilityduration)
	elseif (msgtype == "DISEASE") then
		self.warningmessage = string.gsub(string.gsub(self.db.profile.debuffdiseasemessage, "{a}", ability), "{d}", self.abilityduration)
	elseif (msgtype == "HEALREQ") then
		self.warningmessage = string.gsub(string.gsub(self.db.profile.healreqmessage, "{a}", ability), "{d}", self.abilityduration)
	end
	
	--only for testing
	--if (self.isDebug) then
	--	SendChatMessage(self.warningmessage, "SAY")
	--end
	
	if (msgtype == "COUNTERSPELL") then
	local ability = "Shield Bash", "Pummel", "Strangulate"
	-- Say
	if self.db.profile.outputsettings[ability].say then
		SendChatMessage(self.warningmessage, "SAY")
	end
	
	-- Party- or Raidchat warning
	if self.db.profile.outputsettings[ability].raid then
		if (GetNumRaidMembers() > 0) then
			SendChatMessage(self.warningmessage, "RAID")
		elseif (GetNumPartyMembers() > 0) then
			SendChatMessage(self.warningmessage, "PARTY")
		end
	end
	
	-- Raidwarning
	if self.db.profile.outputsettings[ability].raidwarning then
		if (GetNumRaidMembers() > 0) and IsRaidOfficer() then
			SendChatMessage(self.warningmessage, "RAID_WARNING")
		end
	end
	
	-- custom channel warning
	for j=1,table.getn(self.db.profile.outputsettings[ability].channel) do
		if (self.db.profile.outputsettings[ability].channel[j] ~= nil) then 
			local index = GetChannelName(self.db.profile.outputsettings[ability].channel[j])
			if (index~=nil) then 
				SendChatMessage(self.warningmessage, "CHANNEL", nil, index); 
			end
		end
	end
	end
	
	if (msgtype ~= "COUNTERSPELL") then
	-- Say
	if self.db.profile.outputsettings[L:GetReverseTranslation(ability)].say then
		SendChatMessage(self.warningmessage, "SAY")
	end
	
	-- Party- or Raidchat warning
	if self.db.profile.outputsettings[L:GetReverseTranslation(ability)].raid then
		if (GetNumRaidMembers() > 0) then
			SendChatMessage(self.warningmessage, "RAID")
		elseif (GetNumPartyMembers() > 0) then
			SendChatMessage(self.warningmessage, "PARTY")
		end
	end
	
	-- Raidwarning
	if self.db.profile.outputsettings[L:GetReverseTranslation(ability)].raidwarning then
		if (GetNumRaidMembers() > 0) and IsRaidOfficer() then
			SendChatMessage(self.warningmessage, "RAID_WARNING")
		end
	end
	
	-- custom channel warning
	for j=1,table.getn(self.db.profile.outputsettings[L:GetReverseTranslation(ability)].channel) do
		if (self.db.profile.outputsettings[L:GetReverseTranslation(ability)].channel[j] ~= nil) then 
			local index = GetChannelName(self.db.profile.outputsettings[L:GetReverseTranslation(ability)].channel[j])
			if (index~=nil) then 
				SendChatMessage(self.warningmessage, "CHANNEL", nil, index); 
			end
		end
	end	
	end
	
	if ((msgtype ~= "ABILITY") and (msgtype ~= "ABILITYENDS") and (msgtype ~= "ABILITYONTARGET") and (msgtype ~= "ABILITYONTARGETENDS") and (msgtype ~= "INSTANTCAST") and (msgtype ~= "COUNTERSPELL") and (msgtype ~= "PROC") and (msgtype ~= "DEBUFF") and (msgtype ~= "DEBUFFENDS") and (msgtype ~= "DISARM") and (msgtype ~= "DISARMENDS") and (msgtype ~= "STUN") and (msgtype ~= "MAGIC") and (msgtype ~= "CURSE") and (msgtype ~= "POISON") and (msgtype ~= "DISEASE") and (msgtype ~= "HEALREQ")) then
			
		-- Autowhisper
		if self.db.profile.outputsettings[L:GetReverseTranslation(ability)].whisper and (UnitName("targettarget") ~= nil) and (UnitPlayerControlled("targettarget")) then
			_, englishClass = UnitClass("targettarget");
		
			if (not self.db.profile.whisperWarriors and englishClass == "WARRIOR") then
			-- This (below) is planned but so far we are not sure if a we are talking to a tankadin or a feral druid...
			--if (not self.db.profile.whisperWarriors and englishClass == "WARRIOR" or "PALADIN" or "DRUID") then
				--
			else
				-- we will do class dependent warnings, just for fun
				if (englishClass == "WARRIOR") then
					self.ResistWhisperMessage = L["Resist-Whisper-Message-Warrior"]
				elseif (englishClass == "DRUID") then
					self.ResistWhisperMessage = L["Resist-Whisper-Message-Druid"]
				elseif (englishClass == "MAGE") then
					self.ResistWhisperMessage = L["Resist-Whisper-Message-Mage"]
				elseif (englishClass == "WARLOCK") then
					self.ResistWhisperMessage = L["Resist-Whisper-Message-Warlock"]
				elseif (englishClass == "PALADIN") then
					self.ResistWhisperMessage = L["Resist-Whisper-Message-Paladin"]
				elseif (englishClass == "PRIEST") then
					self.ResistWhisperMessage = L["Resist-Whisper-Message-Priest"]
				elseif (englishClass == "HUNTER") then
					self.ResistWhisperMessage = L["Resist-Whisper-Message-Hunter"]
				elseif (englishClass == "ROGUE") then
					self.ResistWhisperMessage = L["Resist-Whisper-Message-Rogue"]
				elseif (englishClass == "SHAMAN") then
					self.ResistWhisperMessage = L["Resist-Whisper-Message-Shaman"]
				else 
					self.ResistWhisperMessage = L["Resist-Whisper-Message-Deathknight"]
				end
				
				SendChatMessage(self.warningmessage.." "..self.ResistWhisperMessage, "WHISPER", nil, UnitName("targettarget"));
			end
		end
	end
end

-- Audio alert
function OptiTaunt:giveAudioAlert()
	if (self.db.profile.giveAudioWarning) then
			PlaySound("GAMEHIGHLIGHTFRIENDLYUNIT"); --workaround from wowace-forums for buggy soundsystem
			PlaySoundFile(self.tauntsoundfile);
	end
end


-- prints taunt statistics
function OptiTaunt:PrintTauntStatistics()

local TauntStaticticsTitle = "|cffff6d00OptiTaunt >|r "

	if ((GetNumRaidMembers() == 0) and (GetNumPartyMembers() == 0)) then
			DEFAULT_CHAT_FRAME:AddMessage(TauntStaticticsTitle..L["Taunts"].." "..self.tauntcount.."  "..L["Resisted"].." "..self.tauntresistcount.." ("..self.tauntresistpercent.."%)")
	elseif (GetNumRaidMembers() > 0) then
			SendChatMessage("OptiTaunt > "..L["Taunts"].." "..self.tauntcount.."  "..L["Resisted"].." "..self.tauntresistcount.." ("..self.tauntresistpercent.."%)", "RAID")
	elseif (GetNumPartyMembers() > 0) then
			SendChatMessage("OptiTaunt > "..L["Taunts"].." "..self.tauntcount.."  "..L["Resisted"].." "..self.tauntresistcount.." ("..self.tauntresistpercent.."%)", "PARTY")
	end
end

-- Reset Counter
function OptiTaunt:ResetCounters()
	self.tauntcount = 0
	self.tauntresistcount = 0
	self.tauntresistpercent = 0
end


--[[
---- Toggle Options -------------------------------------------------------------------------------
]]

-- Announcement
function OptiTaunt:IsShowInRaidAnnouncement()
    return self.db.profile.showInRaidAnnouncement
end

function OptiTaunt:ToggleShowInRaidAnnouncement()
    self.db.profile.showInRaidAnnouncement = not self.db.profile.showInRaidAnnouncement
end

function OptiTaunt:IsShowInRaidPartyChat()
    return self.db.profile.showInRaidPartyChat
end

function OptiTaunt:ToggleShowInRaidPartyChat()
    self.db.profile.showInRaidPartyChat = not self.db.profile.showInRaidPartyChat
end


-- AutoWhisper
function OptiTaunt:IsAutoWhisper()
    return self.db.profile.autoWhisper
end

function OptiTaunt:ToggleAutoWhisper()
    self.db.profile.autoWhisper = not self.db.profile.autoWhisper
end


-- AudioWarning
function OptiTaunt:IsGiveAudioWarning()
    return self.db.profile.giveAudioWarning
end

function OptiTaunt:ToggleGiveAudioWarning()
    self.db.profile.giveAudioWarning = not self.db.profile.giveAudioWarning
end


-- AggroCheck
function OptiTaunt:IsAggroCheck()
    return self.db.profile.aggroCheck
end

function OptiTaunt:ToggleAggroCheck()
    self.db.profile.aggroCheck = not self.db.profile.aggroCheck
end


-- Whisper Warriors
function OptiTaunt:IsWhisperWarriors()
    return self.db.profile.whisperWarriors
end

function OptiTaunt:ToggleWhisperWarriors()
    self.db.profile.whisperWarriors = not self.db.profile.whisperWarriors
end


-- PvP
function OptiTaunt:IsPvPCheck()
    return self.db.profile.pvpCheck
end

function OptiTaunt:TogglePvPCheck()
    self.db.profile.pvpCheck = not self.db.profile.pvpCheck
end


-- Resist
function OptiTaunt:GetResistMessage()
	return self.db.profile.resistmessage
end
	
function OptiTaunt:SetResistMessage(arg1)
	self.db.profile.resistmessage = arg1
end

function OptiTaunt:IsAnnounceResist()
	return self.db.profile.announceresist
end

function OptiTaunt:ToggleAnnounceResist()
	self.db.profile.announceresist = not self.db.profile.announceresist
end


-- Immune
function OptiTaunt:GetImmuneMessage()
	return self.db.profile.immunemessage
end
	
function OptiTaunt:SetImmuneMessage(arg1)
	self.db.profile.immunemessage = arg1
end

function OptiTaunt:IsAnnounceImmune()
	return self.db.profile.announceimmune
end

function OptiTaunt:ToggleAnnounceImmune()
	self.db.profile.announceimmune = not self.db.profile.announceimmune
end


-- Ability
function OptiTaunt:GetAbilityMessage()
	return self.db.profile.abilitymessage
end
	
function OptiTaunt:SetAbilityMessage(arg1)
	self.db.profile.abilitymessage = arg1
end

function OptiTaunt:IsAnnounceAbility()
	return self.db.profile.announceability
end

function OptiTaunt:ToggleAnnounceAbility()
	self.db.profile.announceability = not self.db.profile.announceability
end

-- AbilityEnd
function OptiTaunt:GetAbilityEndMessage()
	return self.db.profile.abilityendmessage
end
	
function OptiTaunt:SetAbilityEndMessage(arg1)
	self.db.profile.abilityendmessage = arg1
end

function OptiTaunt:IsAnnounceAbilityEnd()
	return self.db.profile.announceabilityend
end

function OptiTaunt:ToggleAnnounceAbilityEnd()
	self.db.profile.announceabilityend = not self.db.profile.announceabilityend
end


--AbilityOnTarget
function OptiTaunt:GetAbilityOnTargetMessage()
	return self.db.profile.abilityontargetmessage
end
	
function OptiTaunt:SetAbilityOnTargetMessage(arg1)
	self.db.profile.abilityontargetmessage = arg1
end

function OptiTaunt:IsAnnounceAbilityOnTarget()
	return self.db.profile.announceabilityontarget
end

function OptiTaunt:ToggleAnnounceAbilityOnTarget()
	self.db.profile.announceabilityontarget = not self.db.profile.announceabilityontarget
end

--AbilityOnTargetEnd
function OptiTaunt:GetAbilityOnTargetEndMessage()
	return self.db.profile.abilityontargetendmessage
end
	
function OptiTaunt:SetAbilityOnTargetEndMessage(arg1)
	self.db.profile.abilityontargetendmessage = arg1
end

function OptiTaunt:IsAnnounceAbilityOnTargetEnd()
	return self.db.profile.announceabilityontargetend
end

function OptiTaunt:ToggleAnnounceAbilityOnTargetEnd()
	self.db.profile.announceabilityontargetend = not self.db.profile.announceabilityontargetend
end

--InstantCast
function OptiTaunt:GetInstantCastMessage()
	return self.db.profile.instantcastmessage
end
	
function OptiTaunt:SetInstantCastMessage(arg1)
	self.db.profile.instantcastmessage = arg1
end

--Counterspell
function OptiTaunt:GetCounterspellMessage()
	return self.db.profile.counterspellmessage
end
	
function OptiTaunt:SetCounterspellMessage(arg1)
	self.db.profile.counterspellmessage = arg1
end

--Proc
function OptiTaunt:GetProcMessage()
	return self.db.profile.procspellmessage
end
	
function OptiTaunt:SetProcMessage(arg1)
	self.db.profile.procmessage = arg1
end

-- Disarm
function OptiTaunt:GetDisarmMessage()
	return self.db.profile.disarmmessage
end
	
function OptiTaunt:SetDisarmMessage(arg1)
	self.db.profile.disarmmessage = arg1
end

function OptiTaunt:IsAnnounceDisarm()
	return self.db.profile.announcedisarm
end

function OptiTaunt:ToggleAnnounceDisarm()
	self.db.profile.announcedisarm = not self.db.profile.announcedisarm
end

-- DisarmEnd
function OptiTaunt:GetDisarmEndMessage()
	return self.db.profile.disarmendmessage
end
	
function OptiTaunt:SetDisarmEndMessage(arg1)
	self.db.profile.disarmendmessage = arg1
end

function OptiTaunt:IsAnnounceDisarmEnd()
	return self.db.profile.announcedisarmend
end

function OptiTaunt:ToggleAnnounceDisarmEnd()
	self.db.profile.announcedisarmend = not self.db.profile.announcedisarmend
end


-- Debuff
function OptiTaunt:GetDebuffMessage()
	return self.db.profile.debuffmessage
end
	
function OptiTaunt:SetDebuffMessage(arg1)
	self.db.profile.debuffmessage = arg1
end

function OptiTaunt:IsAnnounceDebuff()
	return self.db.profile.announcedebuff
end

function OptiTaunt:ToggleAnnounceDebuff()
	self.db.profile.announcedebuff = not self.db.profile.announcedebuff
end

-- DebuffEnd
function OptiTaunt:GetDebuffEndMessage()
	return self.db.profile.debuffendmessage
end
	
function OptiTaunt:SetDebuffEndMessage(arg1)
	self.db.profile.debuffendmessage = arg1
end

function OptiTaunt:IsAnnounceDebuffEnd()
	return self.db.profile.announcedebuffend
end

function OptiTaunt:ToggleAnnounceDebuffEnd()
	self.db.profile.announcedebuffend = not self.db.profile.announcedebuffend
end

-- Stun
function OptiTaunt:GetDebuffStunMessage()
	return self.db.profile.debuffstunmessage
end
	
function OptiTaunt:SetDebuffStunMessage(arg1)
	self.db.profile.debuffstunmessage = arg1
end

function OptiTaunt:IsAnnounceDebuffStun()
	return self.db.profile.announcedebuffstun
end

function OptiTaunt:ToggleAnnounceDebuffStun()
	self.db.profile.announcedebuffstun = not self.db.profile.announcedebuffstun
end

-- Magic debuff
function OptiTaunt:GetDebuffMagicMessage()
	return self.db.profile.debuffmagicmessage
end
	
function OptiTaunt:SetDebuffMagicMessage(arg1)
	self.db.profile.debuffmagicmessage = arg1
end

function OptiTaunt:IsAnnounceDebuffMagic()
	return self.db.profile.announcedebuffmagic
end

function OptiTaunt:ToggleAnnounceDebuffMagic()
	self.db.profile.announcedebuffmagic = not self.db.profile.announcedebuffmagic
end

-- Curse
function OptiTaunt:GetDebuffCurseMessage()
	return self.db.profile.debuffcursemessage
end
	
function OptiTaunt:SetDebuffCurseMessage(arg1)
	self.db.profile.debuffcursemessage = arg1
end

function OptiTaunt:IsAnnounceDebuffCurse()
	return self.db.profile.announcedebuffcurse
end

function OptiTaunt:ToggleAnnounceDebuffCurse()
	self.db.profile.announcedebuffcurse = not self.db.profile.announcedebuffcurse
end

-- Poison
function OptiTaunt:GetDebuffPoisonMessage()
	return self.db.profile.debuffpoisonmessage
end
	
function OptiTaunt:SetDebuffPoisonMessage(arg1)
	self.db.profile.debuffpoisonmessage = arg1
end

function OptiTaunt:IsAnnounceDebuffPoison()
	return self.db.profile.announcedebuffpoison
end

function OptiTaunt:ToggleAnnounceDebuffPoison()
	self.db.profile.announcedebuffpoison = not self.db.profile.announcedebuffpoison
end

-- Disease
function OptiTaunt:GetDebuffDiseaseMessage()
	return self.db.profile.debuffdiseasemessage
end
	
function OptiTaunt:SetDebuffDiseaseMessage(arg1)
	self.db.profile.debuffdiseasemessage = arg1
end

function OptiTaunt:IsAnnounceDebuffDisease()
	return self.db.profile.announcedebuffdisease
end

function OptiTaunt:ToggleAnnounceDebuffDisease()
	self.db.profile.announcedebuffdisease= not self.db.profile.announcedebuffdisease
end

-- Heal required
function OptiTaunt:GetHealreqMessage()
	return self.db.profile.healreqmessage
end
	
function OptiTaunt:SetHealreqMessage(arg1)
	self.db.profile.healreqmessage = arg1
end

function OptiTaunt:IsAnnounceHealreq()
	return self.db.profile.announcehealreq
end

function OptiTaunt:ToggleAnnounceHealreq()
	self.db.profile.announcehealreq= not self.db.profile.announcehealreq
end


